function val = IsaacECOL_get(obj,propname)
% @IsaacECOL : lecture d'une proprit
%
% propname					val
% --------					---
% 'BitClass'				obj.bitclass
% 'Dimension'				obj.dimension
% 'ICCFilename'			obj.iccfilename
% 'ICCProfile'				obj.iccprofile
% 'IsICC'					vrai si profil ICC, faux sinon
% 'Gamma'					obj.gamma
% 'LightSource'			obj.lightsource
% 'LightSourcesValues'	cellarray des valeurs possibles de obj.lightsource
% 'Name'						obj.name
% 'NamesValues'			cellarray des valeurs possibles de obj.name
% 'WhitePoint'				obj.whitepoint
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

                                                                                         %[tomodify]
% conversion LCH (double) supprime car rsultats plan H entre 50 et 500 (bug Matlab 2007a ?)

switch propname
	case 'BitClass'
		val = obj.bitclass;
	case 'Dimension'
		val = obj.dimension;
	case 'ICCFilename'	
		val = obj.iccfilename;
	case 'ICCProfile'
		val = obj.iccprofile;
	case 'IsICC'
		val = ~isempty(obj.iccprofile);	
	case 'Gamma'
		val = obj.gamma;
	case 'LightSource'
		val = obj.lightsource;
	case 'LightSourcesValues'
		if isempty(obj.iccprofile)
			val = {'?';'D50';'D55';'D65';'D75';'A';'C';'E'};
		else	
			val = {'ICC'};
		end	
	case 'Name'
		val = obj.name;
	case 'NamesValues'
		if isempty(obj.iccprofile)
			val = {'SRGB';'XYZ';'XYL';'LAB';'UVL';'UpVpL';'HSV';'YIQ';'YCbCr'}; %'LCH'
		else
			val = {'ICC'};
		end	
	case 'WhitePoint'
		val = obj.whitepoint;
	otherwise
		error('argument incorrect')
end