function obj = IsaacECOL_set(obj,varargin)
% @IsaacECOL : criture d'une ou plusieurs proprits
%
% (Appeler en TRY-CATCH pour sortie en erreur d'execution)
%
%	obj = IsaacECOL_set(obj,propname1,val1,...,propnameN,valN)
%
% propname			val
% --------			---
% 'Gamma'			obj.gamma
% 'LightSource'	obj.lightsource
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

if (nargin < 3)
	error('nombre d''arguments incorrect')
end
propargin = varargin;
while (length(propargin) >= 2)
	propname = propargin{1};
	val = propargin{2};
	propargin = propargin(3:end);
	switch propname
		case 'Gamma'
			if (val < 0)
				error('valeur gamma incorrecte')
			end	
			obj.gamma = val;
		case 'LightSource'
			if strcmp(obj.name,'ICC')
				if ~strcmp(val,'ICC')
					error('illuminant incompatible')
				end
			else	
				obj.whitepoint = IsaacWhitePoint(char(val));
				if (obj.whitepoint == 0)
					error('illuminant inconnu ou non gr')
				end
			end	
			obj.lightsource = val;
		otherwise
			error('argument incorrect')
	end
end
if ~isempty(propargin)
	error('nombre d''arguments incorrect')
end
