function obj = IsaacHISTO_soushist(obj,plans)
% @IsaacHISTO : sous-histograme selon plans
%
%	- plans : matrice (1,n), n < obj.valmin des dimensions  retenir => impose l'ordre des plans
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

valdim = size(plans,2);
if ((size(plans,1) ~= 1) || (valdim > obj.valdim) || any(plans < 1) || ...
	any(plans > obj.valdim) || (length(unique(plans)) ~= length(plans))) % erreur si doublons
	error('argument incorrect')
end
if obj.valnb
	obj.histo = obj.histo(:,plans);
	[obj.histo,~,ind2] = unique(obj.histo,'rows');
	valnb = size(obj.histo,1);
	counts = obj.counts;
	obj.counts = zeros(valnb,1);
	for i = 1:obj.valnb
		obj.counts(ind2(i)) = obj.counts(ind2(i)) + counts(i);
	end
	clear counts
	obj.valnb = valnb;
	obj.plans = obj.plans(plans);
	obj.valdim = valdim;
	obj.valmin = obj.histo(1,:);
	obj.valmax = obj.histo(obj.valnb,:);
	obj.effmin = min(obj.counts);
	obj.effmax = max(obj.counts);
	obj.effsum = sum(obj.counts);
end
% sinon obj.histo inchang	

