function obj = IsaacHISTO_union(obj,obj2)
% @IsaacHISTO : union de obj et obj2
%
% (Appeler en TRY-CATCH pour sortie en erreur d'execution)
%
%	- obj2	: objet @IsaacHISTO
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

if ~isa(obj2,'IsaacHISTO')
	error('argument incorrect')
end
if ((obj2.valdim ~= obj.valdim) || (obj2.bitclass ~= obj.bitclass))
	error('histogrammes incompatibles')
end
obj.ima_name	= 'Union';
obj.ima_nbpix	= 0;
obj.ima_dimz	= obj.valdim;
obj.ima_nbb		= obj.ima_nbb;
obj.ima_useroi = false;
obj.plans		= 1:obj.valdim;
if ~obj.valnb
	obj.histo	= obj2.histo;
	obj.counts	= obj2.counts;
	obj.valnb	= obj2.valnb;
	obj.valdim	= obj2.valdim;
	obj.valmin	= obj2.valmin;
	obj.valmax	= obj2.valmax;
	obj.effmin	= obj2.effmin;
	obj.effmax	= obj2.effmax;
	obj.effsum	= obj2.effsum;
elseif obj2.valnb
	histo = cat(1,obj.histo,obj2.histo);
	counts = cat(1,obj.counts,obj2.counts);
	nbtotal = obj.valnb + obj2.valnb;
	clear obj2
	[obj.histo,~,ind2] = unique(histo,'rows');
	% le rsultat est tri
	clear histo
	obj.valnb = size(obj.histo,1);
	obj.counts = zeros(obj.valnb,1);
	for i = 1:(nbtotal)
		obj.counts(ind2(i)) = obj.counts(ind2(i)) + counts(i);
	end
	clear counts
	obj.valmin = obj.histo(1,:);
	obj.valmax = obj.histo(obj.valnb,:);
	obj.effmin = min(obj.counts);
	obj.effmax = max(obj.counts);
	obj.effsum = sum(obj.counts);
end
% sinon obj.histo inchang	

