function obj = IsaacIMG_concat(obj,obj2)
% @IsaacIMG : concatne obj2 avec obj en suivant les caractristiques de obj
%        Les ROI sont concatnes, les espaces colorimtriques sont supprims
%
% (Appeler en TRY-CATCH pour sortie en erreur d'execution)
%
%    - obj2 : objet @IsaacIMG
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPREF

if ~isa(obj2,'IsaacIMG')
	error('argument incorrect')
end
% requantification ventuelle
if (obj2.nbb ~= obj.nbb)
	img = IsaacIMG_im2nbb(obj2,obj.nbb);
	if (obj.nbb == 1)
		IsaacMessageWarning(['image ',obj2.imgname,' convertie en logical'])
	else
		IsaacMessageWarning(['image ',obj2.imgname,' convertie en ',num2str(obj.nbb),' bits'])
	end	
else
	img = obj2.img;
end
% redimensionnement ventuel
if ((obj2.dimx ~= obj.dimx) || (obj2.dimy ~= obj.dimy))
	img2 = imresize(img,[obj.dimy,obj.dimx],'nearest');
	IsaacMessageWarning(['image ',obj2.imgname,' redimensionne'])	
else
	img2 = img;
end
clear img
% Concatnation et initialisation du nouvel objet
obj.img = cat(3,obj.img,img2);
clear img2
obj.dimz = obj.dimz + obj2.dimz;
if (obj.dimz > ISAACPREF.ImMaxPlans)
	error('le nombre de plans dpasse la limite fixe en prfrences')
end
obj.min = reshape(double(min(min(obj.img))),1,obj.dimz); % (matrice 1xdimz)
obj.max = reshape(double(max(max(obj.img))),1,obj.dimz); % (matrice 1xdimz)
% Concatnation des ROI et recalcul des masques
obj.roi = IsaacROI_concat(obj.roi,obj2.roi);
if obj.isroi && ~ISAACPREF.OptimiseImgMem
	% si ~obj.isroi les masques restent  false de dimension inchange
	obj.roispamask = IsaacROI_spamask(obj.roi);
	obj.roivalmask = IsaacROI_valmask(obj.roi,obj.img);
end
% Suppression espace colorimtrique
if obj.iscolorspace
	obj.colorspace = IsaacECOL(); % espace indtermin par dfaut
	obj.iscolorspace = false;
end
