function val = IsaacIMG_get(obj,propname)
% @IsaacIMG : lecture d'une proprit
%
% propname				val
% --------				---
% 'BitClass'			obj.bitclass
% 'ColorSpace'			obj.colorspace
% 'ColorSpaceName'		IsaacECOL_get(obj.colorspace,'Name')
% 'DimX'             obj.dimx
% 'DimY'             obj.dimy
% 'DimZ'             obj.dimz
% 'Img'					obj.img
% 'ImgName'				obj.imgname
% 'IsColorSpace'		obj.iscolorspace
% 'IsRoi'				obj.isroi
% 'IsRoiSpa'			obj.isroi && IsaacROI_get(obj.roi,'IsRoiSpa')
% 'IsRoiVal'			obj.isroi && any(IsaacROI_get(obj.roi,'IsRoiVal'))
% 'Min'					obj.min
% 'Max'					obj.max
% 'NbBits'				obj.nbb
% 'Roi'					obj.roi
% 'RoiEff'				effectif RoiMask	
% 'RoiMask'				obj.roispamask & obj.roivalmask en tenant compte de IsRoiSpa et IsRoiVal
% 'RoiSpaEff'			effectif RoiSpaMask	
% 'RoiSpaMask'			obj.roispamask ou IsaacROI_spamask(obj.roi) selon ISAACPREF.OptimiseImgMem
% 'RoiValEff'			effectif RoiValMask	
% 'RoiValMask'			obj.roivalmask ou IsaacROI_valmask(obj.roi) selon ISAACPREF.OptimiseImgMem
% 'ValMax'				obj.valmax
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPREF

switch propname
	case 'BitClass'
		val = obj.bitclass;
	case 'ColorSpace'
		val = obj.colorspace;
	case 'ColorSpaceName'
		val = IsaacECOL_get(obj.colorspace,'Name');
	case 'DimX'
		val = obj.dimx;
	case 'DimY'
		val = obj.dimy;
	case 'DimZ'
		val = obj.dimz;
	case 'Img'
		val = obj.img;
	case 'ImgName'
		val = obj.imgname;
	case 'IsColorSpace'
		val = obj.iscolorspace;
	case 'IsRoi'
		val = obj.isroi;
	case 'IsRoiSpa'
		val = obj.isroi && IsaacROI_get(obj.roi,'IsRoiSpa');
	case 'IsRoiVal'
		val = obj.isroi && any(IsaacROI_get(obj.roi,'IsRoiVal'));
	case 'Min'
		val = obj.min;
	case 'Max'
		val = obj.max;
	case 'NbBits'
		val = obj.nbb;
	case 'Roi'
		val = obj.roi;
	case 'RoiEff'
		val = sum(sum(IsaacIMG_get(obj,'RoiMask')));
	case 'RoiMask'
		isroispa = IsaacIMG_get(obj,'IsRoiSpa');
		isroival = IsaacIMG_get(obj,'IsRoiVal');
		if (isroispa && isroival)
			val = IsaacIMG_get(obj,'RoiSpaMask') & IsaacIMG_get(obj,'RoiValMask');
		elseif isroival
			val = IsaacIMG_get(obj,'RoiValMask');
		else
			val = IsaacIMG_get(obj,'RoiSpaMask'); % vaut pour isroispa ou (~isroispa && ~isroival)
		end
	case 'RoiSpaEff'
		val = sum(sum(IsaacIMG_get(obj,'RoiSpaMask')));
	case 'RoiSpaMask'
		if ISAACPREF.OptimiseImgMem
			val = IsaacROI_spamask(obj.roi);
		else	
			val = obj.roispamask;
		end
	case 'RoiValEff'
		val = sum(sum(IsaacIMG_get(obj,'RoiValMask')));
	case 'RoiValMask'
		if ISAACPREF.OptimiseImgMem
			val = IsaacROI_valmask(obj.roi,obj.img);
		else	
			val = obj.roivalmask;
		end
	case 'ValMax'
		val = obj.valmax;
	otherwise
		error('argument incorrect')
end