function ok = IsaacIMG_isequal(obj1,obj2)													
% @IsaacIMG : retourne true si obj1 et obj2 identiques, false sinon
%
%	- obj1	: objet @IsaacIMG
%	- obj2	: objet @IsaacIMG
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

if ~isa(obj1,'IsaacIMG') || ~isa(obj2,'IsaacIMG')
	error('arguments incorrects')
end
st1 = struct(obj1);
st1 = rmfield(st1,{'roi','colorspace','roispamask','roivalmask','converted'});
st2 = struct(obj2);
st2 = rmfield(st2,{'roi','colorspace','roispamask','roivalmask','converted'});
ok = isequal(st1,st2) && IsaacROI_isequal(obj1.roi,obj2.roi) && ...
	IsaacECOL_isequal(obj1.colorspace,obj2.colorspace);
