function obj = IsaacIMG_rotate(obj,val)
% @IsaacIMG : rotation de l'image dans le sens inverse des aiguilles d'une montre
%        La ROI est tourne idem, l'espace colorimtrique reste inchang
%
%	- val : angle de rotation = 90/180/270 
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPREF

switch val
	case 90
		img2 = reshape(obj.img,obj.dimx,obj.dimy,obj.dimz);
		for i = 1:obj.dimz
			img2(:,:,i) = rot90(obj.img(:,:,i));
		end
		dimx = obj.dimy;
		dimy = obj.dimx;
	case 180
		img2 = obj.img;
		for i = 1:obj.dimz
			img2(:,:,i) = rot90(obj.img(:,:,i),2);
		end
		dimx = obj.dimx;
		dimy = obj.dimy;
	case 270
		img2 = reshape(obj.img,obj.dimx,obj.dimy,obj.dimz);
		for i = 1:obj.dimz
			img2(:,:,i) = rot90(obj.img(:,:,i),3);
		end
		dimx = obj.dimy;
		dimy = obj.dimx;
	otherwise
		error('argument incorrect')
end
obj.img = img2;
obj.dimx = dimx;
obj.dimy = dimy;
% Ajustement de roi
obj.roi = IsaacROI_rotate(obj.roi,val);
if ~ISAACPREF.OptimiseImgMem 
	% recalcul masques
	obj.roispamask = IsaacROI_spamask(obj.roi);
	obj.roivalmask = IsaacROI_valmask(obj.roi,obj.img);
end