function img = IsaacIMG_im2nbb(obj,nbb)
% @IsaacIMG (private) : retourne obj.img en changeant le nb de bits
%
% - nbb	: nouveau nombre de bits (1  16/32/64)
% - img	: matrice image modifie
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

if (nbb == obj.nbb)
	img = obj.img;
	return
end
if (nbb == 1)
	img2 = double(obj.img);
	img = logical(obj.img);
	for i = 1:obj.dimz     
      if verLessThan('matlab', '9.0') 
         % code pour MATLAB 2015b et antrieur
         img(:,:,i) = im2bw(img2(:,:,i)/obj.valmax,0.5);                                        %#ok
      else
         % code pour MATLAB 2016a (9.0) et postrieur
         img(:,:,i) = imbinarize(img2(:,:,i)/obj.valmax,0.5); 
      end
	end
elseif (nbb <= 8)
	img = uint8(round(double(obj.img)*(2^nbb - 1)/obj.valmax));
elseif (nbb <= 16)
	img = uint16(round(double(obj.img)*(2^nbb - 1)/obj.valmax));	
elseif (nbb == 32)
	img = single(obj.img)/obj.valmax;
elseif (nbb == 64)	
	img = double(obj.img)/obj.valmax;
else
	error('argument incorrect')
end
