function scale = IsaacImgScale(scale,dimx,dimy)
% Calcul de l'chelle effective d'une image  partir l'chelle souhaite
% en fonction des dims image et cran
%
% hauteur bouton select = ISAACCONST.EpButCible
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACCONST

% augmentation ventuelle de l'chelle si dims image < minimum requis
while (dimy * scale + ISAACCONST.EpButCible < ISAACCONST.MinFenSize(2)) || ...
		(dimx * scale < ISAACCONST.MinFenSize(1))
	if scale < 1 
		t = round(1/scale);
		scale = 1/(t - 1);
	else
		scale = scale + 1;
	end
end

% rduction ventuelle de l'chelle si > cran 
ajoutx = ISAACCONST.EpFen(3) + ISAACCONST.EpFen(4); 
ajouty = ISAACCONST.EpFen(1) + ISAACCONST.EpFen(2) + ISAACCONST.EpButCible;
% (+ ISAACCONST.EpButCible pour la place du bouton select)
while (((dimy * scale + ajouty) > ISAACCONST.Screen.width) || ...
	((dimx * scale + ajoutx) > ISAACCONST.Screen.height))
	if scale <= 1 
		t = round(1/scale);
		scale = 1/(t + 1);
	else
		scale = scale - 1;
	end
end
end