function obj = IsaacLPIX_add(obj,xy,objIMG)
% @IsaacLPIX : ajoute un ou plusieurs pixels  la liste
%
%	- xy		: matrice (n,2) des coordonnes [x,y] des pixels
%	- objIMG	: objet @IsaacIMG
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

dimx = max(xy(:,1));
dimy = max(xy(:,2)); 
if (~isa(objIMG,'IsaacIMG') || (size(xy,2) ~= 2) || any(xy(:) < 1) || ...
		dimx > IsaacIMG_get(objIMG,'DimX') || (dimy > IsaacIMG_get(objIMG,'DimY')))
	error('argument incorrect')
end
dimz = IsaacIMG_get(objIMG,'DimZ');
% ajustement ventuel des dimensions en compltant par des 0
if obj.nbpix
	if (obj.ima_dimz < dimz)
		obj.pix_mat(:,obj.ima_dimz+3:dimz+2) = zeros(obj.nbpix,dimz-obj.ima_dimz);
		obj.ima_dimz = dimz;
	end
else
	obj.ima_dimz = dimz;
end	
% constitution de la liste des valeurs
img = IsaacIMG_get(objIMG,'Img');
nbpix = size(xy,1);
pixval = zeros(nbpix,obj.ima_dimz);
for i = 1:nbpix
	for j = 1:dimz
		pixval(i,j) = double(img(xy(i,2),xy(i,1),j));
	end
end
% conversion ventuelle en 64 bits
valmax = IsaacIMG_get(objIMG,'ValMax');
if (valmax ~= 1)
	pixval = pixval/valmax;
end
% ajout de la liste et maj image de rfrence
if obj.nbpix
	obj.pix_mat = cat(1,obj.pix_mat,cat(2,xy,pixval));
else
	obj.pix_mat = cat(2,xy,pixval);
end	
obj.nbpix = obj.nbpix + nbpix;
obj.ima_dimx = max(obj.ima_dimx,dimx);
obj.ima_dimy = max(obj.ima_dimy,dimy);



