function obj = IsaacLPIX_change(obj,pos,objIMG)
% @IsaacLPIX : modifie une ou plusieurs lignes de la liste avec de nouvelles coordonnes
%
%	- pos		: matrice(n,3) [i,x,y] d'indices ligne dans obj.pix_mat et de coordonnes de pixels
%	- objIMG	: objet @IsaacIMG
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

dimx = max(pos(:,2));
dimy = max(pos(:,3)); 
if (~obj.nbpix || ~isa(objIMG,'IsaacIMG') || (size(pos,2) ~= 3) || any(pos(:) < 1) ||  ...
	any(pos(:,1) > obj.nbpix) || (dimx > IsaacIMG_get(objIMG,'DimX')) || ...
	(dimy > IsaacIMG_get(objIMG,'DimY')))
	error('argument incorrect')
end
dimz = IsaacIMG_get(objIMG,'DimZ');
% augmentation ventuelle des dimensions en compltant par des 0
if (obj.ima_dimz < dimz)
	obj.pix_mat(:,obj.ima_dimz+3:dimz+2) = zeros(obj.nbpix,dimz-obj.ima_dimz);
	obj.ima_dimz = dimz;
end
% modification de la liste et maj image de rfrence
img = IsaacIMG_get(objIMG,'Img');
newval = zeros(1,obj.ima_dimz);
n = size(pos,1);
valmax = IsaacIMG_get(objIMG,'ValMax');
for i = 1:n
	obj.pix_mat(pos(i,1),1:2) = pos(i,2:3);
	for j = 1:dimz
		newval(j) = double(img(pos(i,3),pos(i,2),j));
	end
	% conversion ventuelle 64 bits
	if (valmax ~= 1)
		newval = newval/valmax;
	end
	obj.pix_mat(pos(i,1),3:end) = newval;
end	
obj.ima_dimx = max(obj.ima_dimx,dimx);
obj.ima_dimy = max(obj.ima_dimy,dimy);
