function obj = IsaacROI_concat(obj,obj2)
% @IsaacROI : ajoute les plans de obj2  ceux de obj en suivant les caractristiques de obj
%				  l'ensemble des lignes de obj et obj2 est ajust et conserv si compatibilit in/out
%
% (Appeler en TRY-CATCH pour sortie en erreur d'execution)
%
%    - obj2 : objet @IsaacROI
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------
% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPREF

if ~isa(obj2,'IsaacROI')
	error('argument incorrect')
end
% Ajustement spatial ventuel de obj2
if obj2.spa_nb
	if (obj2.spa_in == obj.spa_in)
		obj2 = IsaacROI_resize(obj2,obj.ima_dimx,obj.ima_dimy);
	else
		obj2.spa_nb = 0;
		obj2.spa_mat = [];
	end
end	
% requantification ventuelle de obj2
if obj2.val_nb 
	if (obj2.val_in == obj.val_in)
		obj2 = IsaacROI_adjust(obj2,'NBBits',obj.ima_nbb);
	else
		obj2.val_nb = 0;
		obj2.val_mat = [];
	end
end	
% Concatnation et initialisation du nouvel objet
obj.spa_mat = cat(1,obj.spa_mat,obj2.spa_mat);
obj.spa_nb = obj.spa_nb + obj2.spa_nb;
dimz = obj.ima_dimz + obj2.ima_dimz;
if (dimz > ISAACPREF.ImMaxPlans)
	error('le nombre de plans dpasse la limite fixe en prfrences')
end
nb = max(obj.val_nb,obj2.val_nb);
if nb
	valmat = zeros([nb,2*dimz]);
	for i = 1:dimz
		valmat(:,2*i-1) = 0;
		valmat(:,2*i) = obj.valmax;
	end
	if obj.val_nb
		valmat(1:obj.val_nb,1:2*obj.ima_dimz) = obj.val_mat;
	end	
	if obj2.val_nb
		valmat(1:obj2.val_nb,2*obj.ima_dimz+1:2*dimz) = obj2.val_mat;
	end	
else
	valmat = [];
end
obj.val_mat = valmat;
obj.val_nb = nb;
obj.isval = cat(2,obj.isval,obj2.isval);
obj.ima_dimz = dimz;
% Suppression des doublons ventuels
obj = IsaacROI_optimise(obj);
