function obj = IsaacROI_crop(obj,rect)
% @IsaacROI : dcoupe l'image de rfrence selon rect en ajustant la roi spatiale
%				  avec suppression des doublons
%
%	- rect : rectangle
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

try
	if obj.spa_nb
		obj.spa_mat(:,1:2) = obj.spa_mat(:,1:2) - rect(1) + 1;
		obj.spa_mat(:,3:4) = obj.spa_mat(:,3:4) - rect(2) + 1;
		obj.spa_mat(obj.spa_mat(:,1) > rect(3),:) = [];
		obj.spa_mat(obj.spa_mat(:,2) < 1,:) = [];
		obj.spa_mat(obj.spa_mat(:,3) > rect(4),:) = [];
		obj.spa_mat(obj.spa_mat(:,4) < 1,:) = [];
		obj.spa_mat(obj.spa_mat < 1) = 1;
		obj.spa_mat(obj.spa_mat(:,2) > rect(3),2) = rect(3);
		obj.spa_mat(obj.spa_mat(:,4) > rect(4),4) = rect(4);
		% Suppression des doublons ventuels
		obj = IsaacROI_optimise(obj);
	end	
catch
	error('argument incorrect')
end
obj.ima_dimx = rect(3);
obj.ima_dimy = rect(4);