function obj = IsaacROI_remove(obj,varargin)
% @IsaacROI : supprime un ou plusieurs intervalles spatiaux ou valeurs
%
%	obj = IsaacROI_remove(obj,propname1,val1,...,propnameN,valN)
%
% propname	val
% --------	---
% 'RoiSpa'	indice ligne dans obj.spa_mat
% 'RoiVal'	indice ligne dans obj.val_mat
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

propargin = varargin;
while (length(propargin) >= 2)
	propname = propargin{1};
	val = propargin{2};
	propargin = propargin(3:end);
	switch propname
		case 'RoiSpa'
			if ((val < 1) || (val > obj.spa_nb))
				error('argument incorrect')
			end	
			obj.spa_mat(val,:) = [];
			obj.spa_nb = obj.spa_nb - 1;
		case 'RoiVal'
			if ((val < 1) || (val > obj.val_nb))
				error('argument incorrect')
			end	
			obj.val_mat(val,:) = [];
			obj.val_nb = obj.val_nb - 1;
		otherwise
			error('argument incorrect')
	end
end
if ~isempty(propargin)
	error('nombre d''arguments incorrect')
end