function varargout = IsaacModule(modname,varargin)
% Fonction pour appeler un module (ou algorithme)  partir d'un autre module ou d'un outil
%
% (Appeler en TRY-CATCH pour sortie en erreur d'execution) 
%
%	- modname  : nom du module (ou algorithme)
%	- varargin : liste variable des paramtres du module
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACPRIV

[tf,loc] = ismember(modname,{ISAACPRIV.TabMod.filename});
if tf
	savedir = pwd;
	% pour une meilleure performance pas de contrle des paramtres
	% ISAACPRIV.TabMod(loc).isalgo non utilis
	try
		cd(ISAACPRIV.TabMod(loc).dirname)
		% appel du module (ou algorithme) avec en sortie les arguments passs  IsaacModule
		[varargout{1:nargout}] = feval(modname,varargin{:});
    catch exception
		cd(savedir)
        rethrow(exception)
	end
	cd(savedir)
else	
	error(['module "',modname,'" inconnu']);
end	
