function DataEdit_maj(fighnd,varargin)
% Mise  jour de l'affichage dans DataEdit
% (partag par DataEdit et DataEdit_cb)
%
%	DataEdit_maj(fighnd,maj1,...,majN)
%
% - fighnd	: handle figure DataEdit
%
%	propname			
%	--------
%	'Popup'		: maj des popups menus
%	'Valeurs'	: maj des valeurs affiches
%
% Tool for OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

if (nargin < 2)
	error('nombre d''arguments incorrect')
end
propargin = varargin;
ud = get(fighnd,'UserData');
while ~isempty(propargin)
	propname = propargin{1};
	propargin = propargin(2:end);
	switch propname
		case 'Popup'
			MajPopup
		case 'Valeurs'
			MajValues
		otherwise
			error('argument incorrect')
	end
end

% --- Nested fonction ------------------------------------------------------------------------------

function MajPopup

	s = IsaacDATA_get(ud.Param,'TypeValues');
	ind = find(strcmp(s,IsaacDATA_get(ud.Param,'Type')));
	set(findobj(fighnd,'Tag','PopupType'),'String',s,'Value',ind)

end % fin nested fonction

% --- Nested fonction ------------------------------------------------------------------------------

function MajValues

s = IsaacDATA_get(ud.Param,'Class');
set(findobj(fighnd,'Tag','StxtDataClassVal'),'String',s)
s = IsaacDATA_get(ud.Param,'ValStr');
set(findobj(fighnd,'Tag','ListVal'),'String',s)
s = IsaacDATA_get(ud.Param,'Info');
set(findobj(fighnd,'Tag','EtxtInfoVal'),'String',s)
if (ud.PTarget == 1) % workspace 
	set(findobj(fighnd,'Tag','EtxtWSVarname'),'String',ud.WSVarName,'Visible','on')
	set(findobj(fighnd,'Tag','EtxtVarname'),'Visible','off')
elseif (ud.PTarget == 4) % MATLAB
	set(findobj(fighnd,'Tag','EtxtVarname'),'String',ud.PVarName,'Visible','on')
	set(findobj(fighnd,'Tag','EtxtWSVarname'),'Visible','off')
else
	set(findobj(fighnd,'Tag','EtxtVarname'),'Visible','off')
	set(findobj(fighnd,'Tag','EtxtWSVarname'),'Visible','off')
end	

end % fin nested fonction

%---------------------------------------------------------------------------------------------------

end % fin DataEdit_maj en raison des nested fonctions
