function EcolEdit_cb(choix)
% Callback EcolEdit
%
% Tool for OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% N'utilise pas la rception d'vnements causs par (auteur = soi-mme) pour mise  jour graphique

%---------------------------------------------------------------------------------------------------

global ISAACINFO

switch(choix)

% ECOL ---------------------------------------------------------------------------------------------

case 'RadButPredef'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		set(findobj(gcbf,'Tag','RadButICC'),'Value',0)
		ud = get(gcbf,'UserData');
		ud.IsICC = false;
		ud = EcolEdit_maj(gcbf,ud,'Popups','Valeurs','Boutons');
		set(gcbf,'UserData',ud);
	else % tait 1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButICC'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		set(findobj(gcbf,'Tag','RadButPredef'),'Value',0)
		ud = get(gcbf,'UserData');
		ud.IsICC = true;
		ud = EcolEdit_maj(gcbf,ud,'Popups','Valeurs','Boutons');
		set(gcbf,'UserData',ud);
	else % tait 1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'PopupType'
	ud = get(gcbf,'UserData');
	val = get(gcbo,'Value');
	try
		if ud.IsICC
			s1 = get(gcbo,'String');
			ud.Param = IsaacECOL('ICC',s1{val});
		else
			s1 = get(gcbo,'String');
			s2 = get(findobj(gcbf,'Tag','PopupIlluminant'),'String');
			val2 = get(findobj(gcbf,'Tag','PopupIlluminant'),'Value');
			ud.Param = IsaacECOL(s1{val},s2{val2});
		end	
	catch exception
		% rinitialisation du menu
		ud = EcolEdit_maj(gcbf,ud,'Popups','Valeurs','Boutons');
		set(gcbf,'UserData',ud);
		IsaacMessageErreur(IsaacError(exception))
		return
	end
	ud = EcolEdit_maj(gcbf,ud,'Valeurs');
	set(gcbf,'UserData',ud);
case 'PopupIlluminant'
	ud = get(gcbf,'UserData');
	val = get(gcbo,'Value');
	s = get(gcbo,'String');
	try
		ud.Param = IsaacECOL_set(ud.Param,'LightSource',s{val});
	catch exception
		IsaacMessageErreur(IsaacError(exception))
		return
	end
	ud = EcolEdit_maj(gcbf,ud,'Valeurs');
	set(gcbf,'UserData',ud);
case 'ButGamma-'
	ud = get(gcbf,'UserData');
	set(findobj(gcbf,'Tag','ButGamma+'),'Enable','on')
	% pb d'arrondi: a = 1, a = a-0.1 10 fois ne donne pas 0 pile !!!!
	val = IsaacECOL_get(ud.Param,'Gamma');
	g = round(10*val);
	if (g == 1)
		IsaacSound('Buzz')
		set(gcbo,'Enable','off')
	else
		if g > 50
			g = g - 5; 
		else	
			g = g - 1;
		end	
		val = g/10;
		MajGamma
		set(gcbf,'UserData',ud);
	end
case 'ButGammaR'
	ud = get(gcbf,'UserData');
	set(findobj(gcbf,'Tag','ButGamma+'),'Enable','on')
	set(findobj(gcbf,'Tag','ButGamma-'),'Enable','on')
	val = 1;
	MajGamma
	set(gcbf,'UserData',ud);
case 'ButGamma+'
	ud = get(gcbf,'UserData');
	set(findobj(gcbf,'Tag','ButGamma-'),'Enable','on')
	% pb d'arrondi: a = 1, a = a-0.1 10 fois ne donne pas 0 pile !!!!
	val = IsaacECOL_get(ud.Param,'Gamma');
	g = round(10*val);
	if (g == 100)
		IsaacSound('Buzz')
		set(gcbo,'Enable','off')
	else
		if g >= 50
			g = g + 5; 
		else	
			g = g + 1;
		end	
		val = g/10;
		MajGamma
		set(gcbf,'UserData',ud);
	end
	
% Gnral ------------------------------------------------------------------------------------------

case 'CloseBox'
	ud = get(gcbf,'UserData');
	if ~ISAACINFO.IsEnd
		IsaacEventUpdListe(gcbf,[])
	end
	rmpath(ud.ToolDir)
	closereq
case 'RadButParamCible'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.PTarget = 1;
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		set(findobj(gcbf,'Tag','ButParamPull'),'String','Importer')
		set(findobj(gcbf,'Tag','ButParamPush'),'String','Appliquer')
		set(findobj(gcbf,'Tag','ButConvertir'),'Visible','on')
		set(findobj(gcbf,'Tag','ButSupprimer'),'Visible','on')
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','off')
		cible = IsaacImageCible;
		if isempty(cible)
			EcolEdit_upd(gcbf,1,cible,NaN)
		else
			EcolEdit_upd(gcbf,2,cible,NaN)
		end
		% auteur = NaN car EcolEdit_upd n'accepte pas les vnements causs par soi-mme
	else % tait 1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButParamMem'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.PTarget = 2;
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','RadButParamCible'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		set(findobj(gcbf,'Tag','ButParamPull'),'Enable','on','String','Lire')
		if isempty(ud.Param)
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','off','String','Ecrire')
		else
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','on','String','Ecrire')
		end
		set(findobj(gcbf,'Tag','ButConvertir'),'Visible','off')
		set(findobj(gcbf,'Tag','ButSupprimer'),'Visible','off')
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','off')
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
	else % tait 1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButParamFich'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.PTarget = 3;
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','RadButParamCible'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		set(findobj(gcbf,'Tag','ButParamPull'),'Enable','on','String','Ouvrir...')
		if isempty(ud.Param)
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','off','String','Sauver sous...')
		else
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','on','String','Sauver sous...')
		end
		set(findobj(gcbf,'Tag','ButConvertir'),'Visible','off')
		set(findobj(gcbf,'Tag','ButSupprimer'),'Visible','off')
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','off')
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
	else % tait 1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButParamMATLAB'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.PTarget = 4;
		set(gcbf,'UserData',ud)
		set(findobj(gcbf,'Tag','RadButParamCible'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		set(findobj(gcbf,'Tag','ButParamPull'),'Enable','on','String','Importer')
		if isempty(ud.Param)
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','off','String','Exporter')
		else
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','on','String','Exporter')
		end
		set(findobj(gcbf,'Tag','ButConvertir'),'Visible','off')
		set(findobj(gcbf,'Tag','ButSupprimer'),'Visible','off')
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','on')
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
	else % tait  1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end
case 'EtxtVarname'
	ud = get(gcbf,'UserData');
	ud.PVarName = get(gcbo,'String');
	set(gcbf,'UserData',ud);
	set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
case 'ButParamPull'
	ud = get(gcbf,'UserData');
	switch ud.PTarget
		case 1 % Image Cible
			cible = IsaacImageCible;
			ud.Param = IsaacImage_get(cible,'ECOL');
			MajWhenPull
			set(gcbf,'UserData',ud);
		case 2 % Mmoire
			P = IsaacParamPull('ECOL');
			if isempty(P)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','mmoire vide')
			else
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String','mmoire lue')
				ud.Param = P;
				MajWhenPull
				set(gcbf,'UserData',ud);
			end	
		case 3 % Fichier
			[filename,dirname] = IsaacUIgetfile('Ouvrir un espace colorimtrique :');
			if filename == 0
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
				return
			end
			try
				ud.Param = IsaacECOL(fullfile(dirname,filename));
				IsaacCD(dirname)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['fichier ',filename,' lu'])
				MajWhenPull
				set(gcbf,'UserData',ud);
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec lecture fichier')
				return
			end
		case 4 % MATLAB base workspace
			try
				ud.Param = IsaacParamImport('ECOL',ud.PVarName);
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['variable ',ud.PVarName,' importe'])
				MajWhenPull
				set(gcbf,'UserData',ud);
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec import MATLAB')
				return
			end	
	end
case 'ButParamPush'
	ud = get(gcbf,'UserData');
	switch ud.PTarget
		case 1 % Image Cible
			cible = IsaacImageCible;
			try
 				IsaacImage_set(cible,gcbf,'ECOL',ud.Param);
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				return
			end
			set(findobj(gcbf,'Tag','ButParamPull'),'Enable','on')
			set(findobj(gcbf,'Tag','ButConvertir'),'Enable','on')
			set(findobj(gcbf,'Tag','ButSupprimer'),'Enable','on')
		case 2 % Mmoire
			IsaacParamPush(ud.Param)
			set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
				'String','ECOL mmoris')
		case 3 % Fichier
			[filename,dirname] = IsaacUIputfile('Sauver sous :',IsaacFileName('ECOL.mat'));
			if filename == 0
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
				return
			end
			try
				IsaacECOL_saveas(ud.Param,fullfile(dirname,filename));
				IsaacCD(dirname)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
				'String',['fichier ',filename,' sauv'])
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec criture fichier')
				return
			end
		case 4 % MATLAB base workspace
			try
				IsaacParamExport(ud.Param,ud.PVarName)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['variable ',ud.PVarName,' exporte'])
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec export MATLAB')
				return
			end	
	end	
case 'ButConvertir'
	ud = get(gcbf,'UserData');
	cible = IsaacImageCible;
	objIMG = IsaacImage_get(cible,'IMG');
	try
		IsaacImage_set(cible,gcbf,'IMG',IsaacIMG_colorconv(objIMG,ud.Param));
	catch exception
		IsaacMessageErreur(IsaacError(exception))
	end
case 'ButSupprimer'
	ud = get(gcbf,'UserData');
	cible = IsaacImageCible;
	try
		IsaacImage_set(cible,gcbf,'ECOL',[]);
	catch exception
		IsaacMessageErreur(IsaacError(exception))
		return
	end
	set(gcbo,'Enable','off')
	set(findobj(gcbf,'Tag','ButParamPull'),'Enable','off')
	set(findobj(gcbf,'Tag','ButConvertir'),'Enable','off')
end

% --- Nested fonction ------------------------------------------------------------------------------

function MajWhenPull

isicc = IsaacECOL_get(ud.Param,'IsICC');
if isicc
	s1 = IsaacDir(ISAACINFO.ProfilsDir,'f',false,false);
	name = IsaacECOL_get(ud.Param,'ICCFilename');
	ind1 = find(strcmp(name,s1));
	if isempty(ind1)
		% ajout du profil dans le rpertoire ISAACINFO.ProfilsDir
		profil = IsaacECOL_get(ud.Param,'ICCProfile');
		try
			% lors de certaines critures, iccwrite emet un warning d'arrondi de valeurs non
			% entires vers uint8 ou uint16
			warning off
			iccwrite(profil,fullfile(ISAACINFO.ProfilsDir,name));
			warning on
		catch
			IsaacMessageErreur('ajout du fichier profil ICC impossible')
			return
		end
		IsaacMessageWarning(['fichier profil ICC ',name,' ajout'])
		s1 = cat(1,s1,name);
		ind1 = size(s1,1);
	end	
else
	s1 = IsaacECOL_get(ud.Param,'NamesValues');
	name = IsaacECOL_get(ud.Param,'Name');
	ind1 = find(strcmp(name,s1));
	if isempty(ind1)
		IsaacMessageErreur('espace colorimtrique inconnu ou non gr')
		return
	end
end	
s2 = IsaacECOL_get(ud.Param,'LightSourcesValues'); 
ind2 = find(strcmp(IsaacECOL_get(ud.Param,'LightSource'),s2));
if isempty(ind2)
	IsaacMessageErreur('illuminant inconnu ou non gr')
	return
end
set(findobj(gcbf,'Tag','PopupType'),'Enable','on', ...
	'ForegroundColor',ISAACINFO.TextColor1,'String',s1,'Value',ind1(1))
set(findobj(gcbf,'Tag','PopupIlluminant'),'Enable','on','String',s2,'Value',ind2(1))
ud.IsICC = isicc;
set(findobj(gcbf,'Tag','RadButPredef'),'Enable','on','Value',~ud.IsICC)
set(findobj(gcbf,'Tag','RadButICC'),'Enable','on','Value',ud.IsICC)
ud = EcolEdit_maj(gcbf,ud,'Valeurs','Boutons');

end % fin nested fonction

% --- Nested fonction ------------------------------------------------------------------------------

function MajGamma
	
try
	ud.Param = IsaacECOL_set(ud.Param,'Gamma',val);
catch exception
	IsaacMessageErreur(IsaacError(exception))
	return
end
set(findobj(gcbf,'Tag','StxtGammaVal'),'String',num2str(val,'%.1f'))
	
end % fin nested fonction

%---------------------------------------------------------------------------------------------------

end % fin EcolEdit_cb en raison des nested fonctions
