function HistoEdit_cb(choix)
% Callback HistoEdit
%
% Tool for OpenIsaac
%  2018-2020 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2020 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% N'utilise pas la rception d'vnements causs par (auteur = soi-mme) pour mise  jour graphique

%---------------------------------------------------------------------------------------------------

global ISAACINFO

switch(choix)

% HISTO --------------------------------------------------------------------------------------------
case 'PopupDim'
	ud = get(gcbf,'UserData');
	val = get(gcbo,'Value');
	if (val < ud.AffDim)
		ud.AffPlans = ud.AffPlans(1:val);
	elseif (val > ud.AffDim)
		reste = setdiff(1:ud.NbPlans,ud.AffPlans);
		ud.AffPlans(ud.AffDim + 1:val) = reste(1:val-ud.AffDim);
	end
	ud.AffDim = val;
	ud = HistoEdit_maj(gcbf,ud,'Plans','Vue3D');
	UpdDim
	UpdHisto
	ud = HistoEdit_maj(gcbf,ud,'Nom','Effectifs'); % aprs mise  jour histo et counts
	ShowHisto(ud)
	set(gcbf,'UserData',ud)
case 'PopupPlan1'
	ud = get(gcbf,'UserData');
	val = get(gcbo,'Value');
	if (ud.AffDim > 1)
		hnd = findobj(gcbf,'Tag','PopupPlan2');
		val1 = get(hnd,'Value');
		if (val1 == val)
			reste = setdiff(1:ud.NbPlans,val);
			val1 = reste(1);
			set(hnd,'Value',val1);
		end
		if (ud.AffDim > 2)
			hnd = findobj(gcbf,'Tag','PopupPlan3');
			val2 = get(hnd,'Value');
			if (val2 == val) || (val2 == val1)
				reste = setdiff(1:ud.NbPlans,[val,val1]);
				val2 = reste(1);
				set(hnd,'Value',val2);
			end
			ud.AffPlans = [val,val1,val2];
		else
			ud.AffPlans = [val,val1];
		end	
	else
		ud.AffPlans = val;
	end	
	UpdHisto
	ud = HistoEdit_maj(gcbf,ud,'Nom','Effectifs'); % aprs mise  jour histo et counts
	ShowHisto(ud)
	set(gcbf,'UserData',ud)
case 'PopupPlan2'
	ud = get(gcbf,'UserData');
	val = get(gcbo,'Value');
	hnd = findobj(gcbf,'Tag','PopupPlan1');
	val1 = get(hnd,'Value');
	if (val1 == val)
		reste = setdiff(1:ud.NbPlans,val);
		val1 = reste(1);
		set(hnd,'Value',val1);
	end
	if (ud.AffDim > 2)
		hnd = findobj(gcbf,'Tag','PopupPlan3');
		val2 = get(hnd,'Value');
		if (val2 == val) || (val2 == val1)
			reste = setdiff(1:ud.NbPlans,[val,val1]);
			val2 = reste(1);
			set(hnd,'Value',val2);
		end
		ud.AffPlans = [val1,val,val2];
	else
		ud.AffPlans = [val1,val];
	end
	UpdHisto
	ud = HistoEdit_maj(gcbf,ud,'Nom','Effectifs'); % aprs mise  jour histo et counts
	ShowHisto(ud)
	set(gcbf,'UserData',ud)
case 'PopupPlan3'
	ud = get(gcbf,'UserData');
	val = get(gcbo,'Value');
	hnd = findobj(gcbf,'Tag','PopupPlan1');
	val1 = get(hnd,'Value');
	if (val1 == val)
		reste = setdiff(1:ud.NbPlans,val);
		val1 = reste(1);
		set(hnd,'Value',val1);
	end
	hnd = findobj(gcbf,'Tag','PopupPlan2');
	val2 = get(hnd,'Value');
	if (val2 == val) || (val2 == val1)
		reste = setdiff(1:ud.NbPlans,[val,val1]);
		val2 = reste(1);
		set(hnd,'Value',val2);
	end
	ud.AffPlans = [val1,val2,val];
	UpdHisto
	ud = HistoEdit_maj(gcbf,ud,'Nom','Effectifs'); % aprs mise  jour histo et counts
	ShowHisto(ud)
	set(gcbf,'UserData',ud)
case 'RadShowGraph'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		set(findobj(gcbf,'Tag','RadShowInfos'),'Value',0)
		ud = get(gcbf,'UserData');
		ud.ShowGraph = true;
		UpdDim
		ud = HistoEdit_maj(gcbf,ud,'Effectifs','Vue3D');
		ShowHisto(ud)
		set(gcbf,'UserData',ud)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadShowInfos'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		set(findobj(gcbf,'Tag','RadShowGraph'),'Value',0)
		ud = get(gcbf,'UserData');
		ud.ShowGraph = false;
		UpdDim
		ud = HistoEdit_maj(gcbf,ud,'Effectifs','Vue3D');
		ShowHisto(ud)
		set(gcbf,'UserData',ud)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end		
case 'EtxtEffVisMin'
	ud = get(gcbf,'UserData');
	vstr = get(gcbo,'String');
	v = round(str2double(vstr));
	if(isnan(v) || ~isequal(size(v),[1 1]) || (v < 0) || (v > ud.VisMax))
		% (ordre des termes du if important au cas ou v de dim>1)
		IsaacSound('Buzz')
		set(gcbo,'String',num2str(ud.VisMin))
	else
		set(gcbo,'String',num2str(v))
		ud.VisMin = v;
		ud = HistoEdit_maj(gcbf,ud,'Effectifs');
		ShowHisto(ud)
		set(gcbf,'UserData',ud)
	end	
case 'EtxtEffVisMax'
	ud = get(gcbf,'UserData');
	val = IsaacHISTO_get(ud.Param,'CountsRef');
	vstr = get(gcbo,'String');
	v = round(str2double(vstr));
	if(isnan(v) || ~isequal(size(v),[1 1]) || (v > val.effmax) || (v < ud.VisMin))
		% (ordre des termes du if important au cas ou v de dim>1)
		IsaacSound('Buzz')
		set(gcbo,'String',num2str(ud.VisMax))
	else 
		set(gcbo,'String',num2str(v))
		ud.VisMax = v;
		ud = HistoEdit_maj(gcbf,ud,'Effectifs');
		ShowHisto(ud)
		set(gcbf,'UserData',ud)
	end
case 'RadRoiNon'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		set(findobj(gcbf,'Tag','RadRoiOui'),'Value',0)
		set(findobj(gcbf,'Tag','RadRoiVoir'),'Value',0)
		set(findobj(gcbf,'Tag','ChkRoiMark'),'Enable','off','Value',0)
		ud = get(gcbf,'UserData');
		ud.AffRoi = 0;
		UpdHisto
		ud = HistoEdit_maj(gcbf,ud,'Nom','Effectifs'); % aprs mise  jour histo et counts
		ShowHisto(ud)
		set(gcbf,'UserData',ud)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadRoiOui'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		set(findobj(gcbf,'Tag','RadRoiNon'),'Value',0)
		set(findobj(gcbf,'Tag','RadRoiVoir'),'Value',0)
		set(findobj(gcbf,'Tag','ChkRoiMark'),'Enable','off','Value',0)
		ud = get(gcbf,'UserData');
		ud.AffRoi = 1;
		UpdHisto
		ud = HistoEdit_maj(gcbf,ud,'Nom','Effectifs'); % aprs mise  jour histo et counts
		ShowHisto(ud)
		set(gcbf,'UserData',ud)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadRoiVoir'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		set(findobj(gcbf,'Tag','RadRoiNon'),'Value',0)
		set(findobj(gcbf,'Tag','RadRoiOui'),'Value',0)
		ud = get(gcbf,'UserData');
		if (ud.AffDim < 3)
			set(findobj(gcbf,'Tag','ChkRoiMark'),'Enable','on','Value',ud.IsRoiMark)
		end	
		ud.AffRoi = 2;
		UpdHisto
		ud = HistoEdit_maj(gcbf,ud,'Nom','Effectifs'); % aprs mise  jour histo et counts
		ShowHisto(ud)
		set(gcbf,'UserData',ud)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'ChkRoiMark'
	ud = get(gcbf,'UserData');
	ud.IsRoiMark = logical(get(gcbo,'Value'));
	ShowHisto(ud)
	set(gcbf,'UserData',ud)
case 'ButUnion'
	ud = get(gcbf,'UserData');
	ud.HistoCopy = IsaacParamPull('HISTO');
	if isempty(ud.HistoCopy)
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
			'String','mmoire vide')
	else
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
			'String','union')
		try
			ud.Param = IsaacHISTO_union(ud.Param,ud.HistoCopy);
			ud.HistoCopy = ud.Param;
			MajWhenPull
			set(gcbf,'UserData',ud);
		catch
			set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
				'String','histogrammes incompatibles')
		end	
	end	
case 'ButIntersect'
	ud = get(gcbf,'UserData');
	ud.HistoCopy = IsaacParamPull('HISTO');
	if isempty(ud.HistoCopy)
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
			'String','mmoire vide')
	else
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
			'String','intersection ')
		try
			ud.Param = IsaacHISTO_intersect(ud.Param,ud.HistoCopy);
			ud.HistoCopy = ud.Param;
			MajWhenPull
			set(gcbf,'UserData',ud);
		catch
			set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
				'String','histogrammes incompatibles')
		end	
	end	
case 'ButDiffer'
	ud = get(gcbf,'UserData');
	ud.HistoCopy = IsaacParamPull('HISTO');
	if isempty(ud.HistoCopy)
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
			'String','mmoire vide')
	else
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
			'String','diffrence')
		try
			ud.Param = IsaacHISTO_setdiff(ud.Param,ud.HistoCopy);
			ud.HistoCopy = ud.Param;
			MajWhenPull
			set(gcbf,'UserData',ud);
		catch
			set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
				'String','histogrammes incompatibles')
		end	
	end	
case 'ButHistG'
	ud = get(gcbf,'UserData');
	ud.AZ = ud.AZ - 20;
	if (ud.AZ < -180)
		ud.AZ = ud.AZ + 360; 
	end
	view([ud.AZ,ud.EL])
	set(gcbf,'UserData',ud)
case 'ButHistB'
	set(findobj(gcbf,'Tag','ButHistH'),'Enable','on')
	ud = get(gcbf,'UserData');
	if (ud.EL == 0) 
		set(gcbo,'Enable','off')
	else
		ud.EL = ud.EL - 10;
    end
    if ~verLessThan('matlab', '9.6') 
       	% code pour MATLAB 2019a (9.6) et postrieur
        if (ud.AffDim == 2 && ud.EL == 80)
            % cas ou ud.EL valait avant 90
            ShowHisto(ud) % raffichage histo 2D avec Marker = 'none' si ud.EL ? 90
        end    
    end    
	view([ud.AZ,ud.EL])
	set(gcbf,'UserData',ud)
case 'ButHistC'
	set(findobj(gcbf,'Tag','ButHistH'),'Enable','on')
	set(findobj(gcbf,'Tag','ButHistB'),'Enable','on')
	ud = get(gcbf,'UserData');
	ud.AZ = -20;
	ud.EL = 30;
    if ~verLessThan('matlab', '9.6') 
       	% code pour MATLAB 2019a (9.6) et postrieur
        if (ud.AffDim == 2)
            ShowHisto(ud) % raffichage histo 2D avec Marker = 'none' si ud.EL ? 90
        end    
    end    
	view([ud.AZ,ud.EL])
	set(gcbf,'UserData',ud)
case 'ButHistH'
	set(findobj(gcbf,'Tag','ButHistB'),'Enable','on')
	ud = get(gcbf,'UserData');
	if (ud.EL == 90) 
		set(gcbo,'Enable','off')
	else
		ud.EL = ud.EL + 10;
    end
    if ~verLessThan('matlab', '9.6') 
       	% code pour MATLAB 2019a (9.6) et postrieur
        if (ud.AffDim == 2 && ud.EL == 90)
            % quand lvation = 90 la vue 2D (view) n'affiche rien avec Marker = 'none'
            ShowHisto(ud) % raffichage avec Marker = '.'
        end    
    end    
    view([ud.AZ,ud.EL])
    set(gcbf,'UserData',ud)
case 'ButHistD'
	ud = get(gcbf,'UserData');
	ud.AZ = ud.AZ + 20;
	if (ud.AZ > 180) 
		ud.AZ = ud.AZ - 360;
	end
	view([ud.AZ,ud.EL])
	set(gcbf,'UserData',ud)
case 'ChkBigDot'
	ud = get(gcbf,'UserData');
	ud.BigDot = logical(get(gcbo,'Value'));
	ShowHisto(ud)
	set(gcbf,'UserData',ud)
case 'ButScreenCopy'
	ud = get(gcbf,'UserData');
	if (ud.AffDim == 1)
		rect = [271,90,368,340];
	else
		rect = [271,40,368,385];
	end
	figure(gcbf)
	IsaacSound('Photo')
	try
      try
         F = getframe(gcbf,rect);
      catch
         % getframe() ne fonctionne pas correctement avec certaines anciennes versions de MATLAB
         % (par exemple 2010b mais OK 2018a) quand la figure n'est pas sur l'cran principal.
         % Pas de bug rfrence Matlab ni de numro de version officiellement concerne.
         % Solution propose le 25 mai 2012 dans MATLAB Answers par MathWorks Support Team :
         IsaacMessageWarning('dplacement obligatoire de la figure sur l''cran principal')
         movegui(gcbf) % replace la figure sur l'cran principal
         F = getframe(gcbf,rect);
      end    
      img = frame2im(F);
      % autre problme depuis R2015b (DPI-Aware Behavior in MATLAB) :
      % When using the getframe function (or the print function with the -r0 option) 
      % on a high-DPI system, the size of the image data array that MATLAB returns is larger than 
      % in previous releases. 
      if (size(img,1) ~= rect(4)) || (size(img,2) ~= rect(3))
         img = imresize(img,[rect(4) rect(3)]);
      end   
      if (ud.PTarget == 1)
         s = ['-',strrep(num2str(ud.AffPlans),' ',''),'-']; % suppression des espaces
         imaref = IsaacHISTO_get(ud.Param,'ImaRef');
         IsaacImage(gcbf,img,['HISTO',s,imaref.name],[],[]);
		else
			historef = IsaacHISTO_get(ud.Param,'HistoRef');
			s = ['HISTO-',num2str(historef.dim),'x',num2str(historef.bitclass)];
			IsaacImage(gcbf,img,s,[],[]);
      end	
	catch exception
		IsaacMessageErreur(IsaacError(exception))
	end
% Gnral ------------------------------------------------------------------------------------------
case 'CloseBox'
	ud = get(gcbf,'UserData');
    if ~ISAACINFO.IsEnd
		IsaacEventUpdListe(gcbf,[])
    end
    rmpath(ud.ToolDir)
	closereq
case 'RadButParamCible'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.PTarget = 1;
		ud.HistoCopy = [];
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		set(findobj(gcbf,'Tag','ButParamPull'),'Visible','off')
		set(findobj(gcbf,'Tag','ButParamPush'),'Visible','off')
		set(findobj(gcbf,'Tag','ButUnion'),'Enable','off')
		set(findobj(gcbf,'Tag','ButIntersect'),'Enable','off')
		set(findobj(gcbf,'Tag','ButDiffer'),'Enable','off')
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','off')
		cible = IsaacImageCible;
		if isempty(cible)
			HistoEdit_upd(gcbf,1,cible,NaN)
		else
			HistoEdit_upd(gcbf,2,cible,NaN)
		end
		% auteur = NaN car HistoEdit_upd n'accepte pas les vnements causs par soi-mme
	else % tait 1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButParamMem'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		oldtarget = ud.PTarget;
		ud.PTarget = 2;
		set(findobj(gcbf,'Tag','RadButParamCible'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		set(findobj(gcbf,'Tag','ButParamPull'),'String','Lire','Visible','on')
		if isempty(ud.Param)
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','off','String','Ecrire','Visible','on')
		else	
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','on','String','Ecrire','Visible','on')
			if (oldtarget == 1)
				ud.HistoCopy = ud.Param;
				MajWhenPull
			end	
			set(findobj(gcbf,'Tag','ButUnion'),'Enable','on')
			set(findobj(gcbf,'Tag','ButIntersect'),'Enable','on')
			set(findobj(gcbf,'Tag','ButDiffer'),'Enable','on')
		end
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','off')
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
	else % tait 1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButParamFich'	
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		oldtarget = ud.PTarget;
		ud.PTarget = 3;
		set(findobj(gcbf,'Tag','RadButParamCible'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		set(findobj(gcbf,'Tag','ButParamPull'),'String','Ouvrir...','Visible','on')
		if isempty(ud.Param)
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','off','String','Sauver sous...', ...
				'Visible','on')
		else	
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','on','String','Sauver sous...', ...
				'Visible','on')
			if (oldtarget == 1)
				ud.HistoCopy = ud.Param;
				MajWhenPull
			end	
		end
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
		set(findobj(gcbf,'Tag','ButUnion'),'Enable','off')
		set(findobj(gcbf,'Tag','ButIntersect'),'Enable','off')
		set(findobj(gcbf,'Tag','ButDiffer'),'Enable','off')
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','off')
	else % tait 1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end
case 'RadButParamMATLAB'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		oldtarget = ud.PTarget;
		ud.PTarget = 4;
		set(findobj(gcbf,'Tag','RadButParamCible'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		set(findobj(gcbf,'Tag','ButParamPull'),'Enable','on','String','Importer','Visible','on')
		if isempty(ud.Param)
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','off','String','Exporter', ...
				'Visible','on')
		else
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','on','String','Exporter', ...
				'Visible','on')
		end
		set(gcbf,'UserData',ud)
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
		set(findobj(gcbf,'Tag','ButUnion'),'Enable','off')
		set(findobj(gcbf,'Tag','ButIntersect'),'Enable','off')
		set(findobj(gcbf,'Tag','ButDiffer'),'Enable','off')
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','on')
	else % tait  1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end
case 'EtxtVarname'
	ud = get(gcbf,'UserData');
	ud.PVarName = get(gcbo,'String');
	set(gcbf,'UserData',ud);
	set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
case 'ButParamPull'
	ud = get(gcbf,'UserData');
	switch ud.PTarget
		case 2 % Mmoire
			P = IsaacParamPull('HISTO');
			if isempty(P)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','mmoire vide')
			else
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String','mmoire lue')
				ud.Param = P;
				ud.HistoCopy = ud.Param;
				MajWhenPull
				set(gcbf,'UserData',ud);
			end	
		case 3 % Fichier
			[filename,dirname] = IsaacUIgetfile('Ouvrir un histogramme :');
			if filename == 0
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
				return
			end
			try
				ud.Param = IsaacHISTO(fullfile(dirname,filename));
				ud.HistoCopy = ud.Param;
				IsaacCD(dirname)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['fichier ',filename,' lu'])
				MajWhenPull
				set(gcbf,'UserData',ud);
         catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec lecture fichier')
				return
			end
		case 4 % MATLAB base workspace
			try
				ud.Param = IsaacParamImport('HISTO',ud.PVarName);
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['variable ',ud.PVarName,' importe'])
				MajWhenPull
				set(gcbf,'UserData',ud);
         catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec import MATLAB')
				return
			end	
	end
case 'ButParamPush'
	ud = get(gcbf,'UserData');
	switch ud.PTarget
		case 2 % Mmoire
			IsaacParamPush(ud.Param)
			set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
				'String','HISTO mmoris')
		case 3 % Fichier
			s = ['-',strrep(num2str(ud.AffPlans),' ',''),'-']; % suppression des espaces
			imaref = IsaacHISTO_get(ud.Param,'ImaRef');
			[filename,dirname] = IsaacUIputfile('Sauver sous :', ...
				IsaacFileName(['HISTO',s,imaref.name],'.mat'));
			if filename == 0
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
				return
			end
			try
				IsaacHISTO_saveas(ud.Param,fullfile(dirname,filename));
				IsaacCD(dirname)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['fichier ',filename,' sauv'])
         catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec criture fichier')
				return
			end
		case 4 % MATLAB base workspace
			try
				IsaacParamExport(ud.Param,ud.PVarName)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
				'String',['variable ',ud.PVarName,' exporte'])
         catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec export MATLAB')
				return
			end				
	end		
end

% --- Nested fonction ------------------------------------------------------------------------------

function MajWhenPull

historef = IsaacHISTO_get(ud.Param,'HistoRef');
ud.NbPlans = historef.dim;	
ud.PlansStr = cellstr(num2str((1:ud.NbPlans)'));
ud.AffDim = ud.NbPlans;
ud.AffPlans = 1:ud.AffDim;
ud = HistoEdit_maj(gcbf,ud,'Plans','Vue3D');
set(findobj(gcbf,'Tag','PopupDim'),'Enable','on','String',ud.PlansStr,'Value',ud.AffDim)
set(findobj(gcbf,'Tag','RadShowInfos'),'Enable','on')
set(findobj(gcbf,'Tag','ButScreenCopy'),'Enable','on')
imaref = IsaacHISTO_get(ud.Param,'ImaRef');
ud.IsRoi = imaref.useroi;
if ud.IsRoi
	ud.AffRoi = 1;
	set(findobj(gcbf,'Tag','RadRoiNon'),'Enable','off','Value',0)
	set(findobj(gcbf,'Tag','RadRoiOui'),'Enable','on','Value',1)
else
	ud.AffRoi = 0;
	set(findobj(gcbf,'Tag','RadRoiNon'),'Enable','on','Value',1)
	set(findobj(gcbf,'Tag','RadRoiOui'),'Enable','off','Value',0)
end	
set(findobj(gcbf,'Tag','RadRoiVoir'),'Enable','off','Value',0)
set(findobj(gcbf,'Tag','ChkRoiMark'),'Enable','off','Value',0)
countsref = IsaacHISTO_get(ud.Param,'CountsRef');	
ud.VisMin = 0;	
ud.VisMax = countsref.effmax;
ud = HistoEdit_maj(gcbf,ud,'Nom','Effectifs','Labels'); % aprs mise  jour histo et counts
if ud.ShowGraph
	set(findobj(gcbf,'Tag','ListHistoInfo'),'Visible','off')
	set(ud.AxHisto,'Visible','on')
	set(findobj(gcbf,'Tag','ChkBigDot'),'Enable','on','Value',ud.BigDot)
else
	set(ud.AxHisto,'Visible','off')
	set(findobj(gcbf,'Tag','ListHistoInfo'),'Visible','on')
	set(findobj(gcbf,'Tag','ChkBigDot'),'Enable','off','Value',0)
end	
ShowHisto(ud)	
	
end % fin nested fonction

% --- Nested fonction ------------------------------------------------------------------------------

function UpdHisto
	
if (ud.PTarget == 1)
	cible = IsaacImageCible;
	ud.Param = IsaacHISTO(IsaacImage_get(cible,'IMG'),(ud.AffRoi == 1),ud.AffPlans);
	if (ud.AffRoi == 2)
		ud.HistoROI = IsaacHISTO(IsaacImage_get(cible,'IMG'),true,ud.AffPlans);
	else
		ud.HistoROI = [];
	end
else
	ud.HistoROI = [];
	ud.Param = IsaacHISTO_soushist(ud.HistoCopy,ud.AffPlans);
end	
ud.VisMin = 0;
countsref = IsaacHISTO_get(ud.Param,'CountsRef');
ud.VisMax = countsref.effmax;

end % fin nested fonction

% --- Nested fonction ------------------------------------------------------------------------------

function UpdDim
	
if ud.ShowGraph
	if ud.IsRoi && (ud.PTarget == 1)
		set(findobj(gcbf,'Tag','RadRoiVoir'),'Enable','on')
	end
	set(findobj(gcbf,'Tag','ListHistoInfo'),'Visible','off')
	set(ud.AxHisto,'Visible','on')
	set(findobj(gcbf,'Tag','ChkBigDot'),'Enable','on','Value',ud.BigDot)
	if ((ud.AffDim == 3) || (ud.AffRoi ~= 2))
		set(findobj(gcbf,'Tag','ChkRoiMark'),'Enable','off','Value',0)
	else
		set(findobj(gcbf,'Tag','ChkRoiMark'),'Enable','on','Value',ud.IsRoiMark)
	end
else
	if (ud.AffRoi == 2)
		ud.AffRoi = 1;
		UpdHisto
		ud = HistoEdit_maj(gcbf,ud,'Nom'); % aprs mise  jour histo et counts
		set(findobj(gcbf,'Tag','RadRoiOui'),'Value',1)
	end
	set(findobj(gcbf,'Tag','RadRoiVoir'),'Enable','off','Value',0)
	set(ud.AxHisto,'Visible','off')
	set(findobj(gcbf,'Tag','ListHistoInfo'),'Visible','on')
	set(findobj(gcbf,'Tag','ChkBigDot'),'Enable','off','Value',0)
	set(findobj(gcbf,'Tag','ChkRoiMark'),'Enable','off','Value',0)
end	

end % fin nested fonction

%---------------------------------------------------------------------------------------------------

end % fin HistoEdit_cb en raison des nested fonctions

