function ImageAjust_upd(fighnd,event,eventobj,auteur)															%#ok
% Raction ImageAjust aux vnements recus
%
%	@<- EVENEMENTS 1/2/31/41/51/61/111
%
% Tool for OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% Accepte les vnements causs par (auteur = soi-mme) pour mise  jour graphique

%---------------------------------------------------------------------------------------------------

%if (auteur == fighnd) 
% 	return
%end	

global ISAACINFO

switch event
case 1
	% pas d'image cible
	set(findobj(fighnd,'Tag','StxtCibleName'),'ForegroundColor',ISAACINFO.TextColor3, ...
		'String','pas d''image cible')
	set(findobj(fighnd,'Tag','StxtDimXVal'),'String','')
	set(findobj(fighnd,'Tag','StxtDimYVal'),'String','')
	set(findobj(fighnd,'Tag','StxtDimZVal'),'String','')
	set(findobj(fighnd,'Tag','ButResize-'),'Enable','off')
	set(findobj(fighnd,'Tag','ButResize+'),'Enable','off')
	set(findobj(fighnd,'Tag','ButCrop'),'Enable','off')
	set(findobj(fighnd,'Tag','ListPlans'),'Enable','off','String','')
	set(findobj(fighnd,'Tag','ButPlanUp'),'Enable','off')
	set(findobj(fighnd,'Tag','ButPlanDown'),'Enable','off')
	set(findobj(fighnd,'Tag','ButRemovePlan'),'Enable','off')
	% popup string = 1 espace (et pas '') sinon le popup ne s'affiche pas
	set(findobj(fighnd,'Tag','PopupNbBits'),'Enable','off','String',' ','Value',1)
	set(findobj(fighnd,'Tag','ButChangeDyn'),'Enable','off')
	set(findobj(fighnd,'Tag','SliderEMin'),'Enable','off')
	set(findobj(fighnd,'Tag','StxtEMinVal'),'String','')
	set(findobj(fighnd,'Tag','SliderEMax'),'Enable','off')
	set(findobj(fighnd,'Tag','StxtEMaxVal'),'String','')
	set(findobj(fighnd,'Tag','ButRot-'),'Enable','off')
	set(findobj(fighnd,'Tag','ButRot+'),'Enable','off')
	set(findobj(fighnd,'Tag','ButMirrorH'),'Enable','off')
	set(findobj(fighnd,'Tag','BuMirrorV'),'Enable','off')
case 2
	% changement cible
	set(findobj(fighnd,'Tag','StxtCibleName'),'ForegroundColor',ISAACINFO.TextColor1, ...
		'String',IsaacImage_get(eventobj,'Name'))
	set(findobj(fighnd,'Tag','ButResize+'),'Enable','on')
	set(findobj(fighnd,'Tag','ButCrop'),'Enable','on')
	s = {'1';'2';'3';'4';'5';'6';'7';'8';'9';'10';'11';'12';'13';'14';'15';'16';'32';'64'};
	set(findobj(fighnd,'Tag','PopupNbBits'),'Enable','on','String',s)
	set(findobj(fighnd,'Tag','ButRot-'),'Enable','on')
	set(findobj(fighnd,'Tag','ButRot+'),'Enable','on')
	set(findobj(fighnd,'Tag','ButMirrorH'),'Enable','on')
	set(findobj(fighnd,'Tag','BuMirrorV'),'Enable','on')
	UpdateValeurs
case {31,41,51,61}
	% rinitialisation ou modif
	UpdateValeurs
case 111
	% changement de nom cible
	set(findobj(fighnd,'Tag','StxtCibleName'),'String',IsaacImage_get(eventobj,'Name'))
end

% --- Nested fonction ------------------------------------------------------------------------------

function UpdateValeurs

ud = get(fighnd,'UserData');
paramr = IsaacImage_get(eventobj,'ParamR');
set(findobj(fighnd,'Tag','StxtDimXVal'),'String',num2str(paramr.dimx))
set(findobj(fighnd,'Tag','StxtDimYVal'),'String',num2str(paramr.dimy))
set(findobj(fighnd,'Tag','StxtDimZVal'),'String',num2str(paramr.dimz))
if (paramr.dimx > 4) && (paramr.dimy > 4)
	set(findobj(fighnd,'Tag','ButResize-'),'Enable','on')
else
	set(findobj(fighnd,'Tag','ButResize-'),'Enable','off')
end
if (paramr.dimz > 1)
	set(findobj(fighnd,'Tag','ListPlans'),'Enable','on')
	set(findobj(fighnd,'Tag','ButRemovePlan'),'Enable','on')
	set(findobj(fighnd,'Tag','ButPlanUp'),'Enable','on')
	set(findobj(fighnd,'Tag','ButPlanDown'),'Enable','on')
else
	set(findobj(fighnd,'Tag','ListPlans'),'Enable','inactive')
	set(findobj(fighnd,'Tag','ButRemovePlan'),'Enable','off')
	set(findobj(fighnd,'Tag','ButPlanUp'),'Enable','off')
	set(findobj(fighnd,'Tag','ButPlanDown'),'Enable','off')
end	
splans= cell(paramr.dimz,1);
if paramr.nbbits > 16
	formatstr = ['%',num2str(ud.PNBDigits),'i   %1.4f   %1.4f'];
else
	formatstr = ['%',num2str(ud.PNBDigits),'i   %6i   %6i'];
end
limits = IsaacImage_get(eventobj,'MinMax');
for i = 1:paramr.dimz
	splans{i} = sprintf(formatstr,i,limits.min(i),limits.max(i));
end
if (ud.Plan > paramr.dimz)
	ud.Plan = paramr.dimz;
end
set(findobj(fighnd,'Tag','ListPlans'),'String',splans,'Value',ud.Plan)
if (paramr.nbbits <= 16)
	set(findobj(fighnd,'Tag','PopupNbBits'),'Value',paramr.nbbits)
elseif (paramr.nbbits == 32)	
	set(findobj(fighnd,'Tag','PopupNbBits'),'Value',17)
else
	set(findobj(fighnd,'Tag','PopupNbBits'),'Value',18)
end
if (paramr.nbbits == 1)
	ud.DynMin = 0;
	ud.DynMax = 1;
	set(findobj(fighnd,'Tag','ButChangeDyn'),'Enable','off')
	set(findobj(fighnd,'Tag','SliderEMin'),'Enable','off','Value',ud.DynMin)
	set(findobj(fighnd,'Tag','StxtEMinVal'),'String','0')
	set(findobj(fighnd,'Tag','SliderEMax'),'Enable','off','Value',ud.DynMax)
	set(findobj(fighnd,'Tag','StxtEMaxVal'),'String','1')
elseif (paramr.nbbits < 32)
	valmax = IsaacImage_get(eventobj,'ValMax');
	set(findobj(fighnd,'Tag','ButChangeDyn'),'Enable','on')
	set(findobj(fighnd,'Tag','SliderEMin'),'Enable','on','Value',ud.DynMin)
	set(findobj(fighnd,'Tag','StxtEMinVal'),'String',num2str(round(valmax*ud.DynMin)))
	set(findobj(fighnd,'Tag','SliderEMax'),'Enable','on','Value',ud.DynMax)
	set(findobj(fighnd,'Tag','StxtEMaxVal'),'String',num2str(round(valmax*ud.DynMax)))
else
	set(findobj(fighnd,'Tag','ButChangeDyn'),'Enable','on')
	set(findobj(fighnd,'Tag','SliderEMin'),'Enable','on','Value',ud.DynMin)
	set(findobj(fighnd,'Tag','StxtEMinVal'),'String',num2str(ud.DynMin))
	set(findobj(fighnd,'Tag','SliderEMax'),'Enable','on','Value',ud.DynMax)
	set(findobj(fighnd,'Tag','StxtEMaxVal'),'String',num2str(ud.DynMax))
end
set(fighnd,'UserData',ud)
end % fin nested fonction

%---------------------------------------------------------------------------------------------------

end % fin ImageAjust_upd en raison des nested fonctions
