function ImageVal()
% Editeur @IsaacImage des valeurs relles de l'image cible
%
% Tool for OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% structure ud : champ UserData
%	ToolDir		: rpertoire de l'outil
%	PNBDigits	: nombre de caractres pour afficher ISAACINFO.ImMaxPlans

%---------------------------------------------------------------------------------------------------

global ISAACINFO

% si ImageVal est dj lanc, l'ammener au premier plan.
h = findobj(allchild(0),'flat','Tag','ImageVal');
if ~isempty(h)
	figure(h(1)) % mise au 1er plan
   return
end

hauteurfig = 330;
% figure(position selon ISAACINFO.DefPos)
h0 = figure( ...
	'CloseRequestFcn','ImageVal_cb CloseBox', ...
	'Name','ImageVal', ...
	'Position',IsaacFenPos(ISAACINFO.DefPos(1),ISAACINFO.DefPos(2),160,hauteurfig,0), ...
	'Tag','ImageVal');

IsaacDefaultProperties(h0)

% text CibleName	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Enable','inactive', ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[0 hauteurfig - 15 160 15], ...
	'Style','text', ...
	'Tag','StxtCibleName');
% text Dimensions
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'Position',[0 hauteurfig - 35 160 15], ...
	'String','Dim X        Dim Y        Dim Z', ...
	'Style','text');
% text DimX val
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[5 hauteurfig - 52 47 15], ...
	'Style','text', ...
	'Tag','StxtDimXVal');
% text DimY val
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[57 hauteurfig - 52 47 15], ...
	'Style','text', ...
	'Tag','StxtDimYVal');
% text DimZ val
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[110 hauteurfig - 52 47 15], ...
	'Style','text', ...
	'Tag','StxtDimZVal');
% sparateur
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.TextColor1, ...
	'Enable','inactive', ...
	'Position',[0 hauteurfig - 60 160 1], ...
	'Style','frame');
% text Effectifs
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'Position',[0 hauteurfig - 80 160 15], ...
	'String','Effectifs', ...
	'Style','text');
% text EffImage
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'Position',[10 hauteurfig - 93 65 15], ...
	'String','Image', ...
	'Style','text');
% text EffImage val	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Enable','inactive', ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[10 hauteurfig - 108 65 15], ...
	'Style','text', ...
	'Tag','StxtEffImageVal');
% text EffRoi
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'Position',[85 hauteurfig - 93 65 15], ...
	'String','ROI', ...
	'Style','text');
% text EffRoi val	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Enable','inactive', ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[85 hauteurfig - 108 65 15], ...
	'Style','text', ...
	'Tag','StxtEffRoiVal');
% sparateur
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.TextColor1, ...
	'Enable','inactive', ...
	'Position',[0 hauteurfig - 118 160 1], ...
	'Style','frame');
% text NbBits
uicontrol('Parent',h0, ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[5 hauteurfig - 143 45 15], ...
	'String','Nb bits :', ...
	'Style','text');
% text NbBits val	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Enable','inactive', ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[55 hauteurfig - 143 50 15], ...
	'Style','text', ...
	'Tag','StxtNbBitsVal');
% text ECOL
uicontrol('Parent',h0, ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[5 hauteurfig - 163 45 15], ...
	'String','ECOL :', ...
	'Style','text');
% text ECOL val	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Enable','inactive', ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[55 hauteurfig - 162 100 15], ...
	'Style','text', ...
	'Tag','StxtECOLVal');
% sparateur
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.TextColor1, ...
	'Enable','inactive', ...
	'Position',[0 hauteurfig - 172 160 1], ...
	'Style','frame');
% text PlansMinMax
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[5 hauteurfig - 195 135 15], ...
	'String','  Plan        Min           Max', ...
	'Style','text');
% Liste Plans
% FontName = Monospaced pour une police non proportionnelle
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Enable','off', ...
	'FontName','Monospaced', ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[5 hauteurfig - 265 150 70], ...
	'SelectionHighlight','off', ...
	'Style','listbox', ...
	'Tag','ListPlans');
% Bouton CreerPlans	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor3, ...
	'Callback','ImageVal_cb ButCreerPlans', ...
	'Position',[5 hauteurfig - 292 150 20], ...
	'String','Image de plans', ...
	'Tag','ButCreerPlans');
% sparateur
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.TextColor1, ...
	'Enable','inactive', ...
	'Position',[0 hauteurfig - 299 160 1], ...
	'Style','frame');
% Bouton Echantillon	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor3, ...
	'Callback','ImageVal_cb ButEchantillon', ...
	'Position',[5 hauteurfig - 325 150 20], ...
	'String','Image chantillon', ...
	'Tag','ButEchantillon');

%---------------------------------------------------------------------------------------------------

% Initialisation

ud.ToolDir = fileparts(mfilename('fullpath'));
ud.PNBDigits = length(num2str(ISAACINFO.ImMaxPlans));
set(h0,'UserData',ud);
addpath(ud.ToolDir)
IsaacEventUpdListe(h0,ud.ToolDir,'ImageVal_upd') % abonnement aux vnements
cible = IsaacImageCible;
if isempty(cible)
	ImageVal_upd(h0,1,cible,NaN)
else
	ImageVal_upd(h0,2,cible,NaN)
end
% auteur = NaN car n'accepte pas les vnements causs par soi-mme pour mise  jour graphique