function ImageVal_upd(fighnd,event,eventobj,auteur)
% Raction ImageVal aux vnements recus
%
%	@<- EVENEMENTS 1/2/31/41/51/61/71/81/111
%
% Tool for OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% N'accepte pas les vnements causs par (auteur = soi-mme) pour mise  jour graphique

%---------------------------------------------------------------------------------------------------

if (auteur == fighnd) 
 	return
end	

global ISAACINFO

switch event
case 1
	% pas d'image cible
	set(findobj(fighnd,'Tag','StxtCibleName'),'ForegroundColor',ISAACINFO.TextColor3, ...
		'String','pas d''image cible')
	set(findobj(fighnd,'Tag','StxtDimXVal'),'String','')
	set(findobj(fighnd,'Tag','StxtDimYVal'),'String','')
	set(findobj(fighnd,'Tag','StxtDimZVal'),'String','')
	set(findobj(fighnd,'Tag','StxtEffImageVal'),'String','')
	set(findobj(fighnd,'Tag','StxtEffRoiVal'),'String','')
	set(findobj(fighnd,'Tag','StxtNbBitsVal'),'String','')
	set(findobj(fighnd,'Tag','StxtECOLVal'),'String','')
	set(findobj(fighnd,'Tag','ButEchantillon'),'Enable','off')
	set(findobj(fighnd,'Tag','ListPlans'),'Enable','off','String','')
	set(findobj(fighnd,'Tag','ButCreerPlans'),'Enable','off')
case 2
	% changement cible ou rinitialisation ou modif totale
	set(findobj(fighnd,'Tag','StxtCibleName'),'ForegroundColor',ISAACINFO.TextColor1, ...
		'String',IsaacImage_get(eventobj,'Name'))
	set(findobj(fighnd,'Tag','ButEchantillon'),'Enable','on')
	set(findobj(fighnd,'Tag','ListPlans'),'Enable','on','Min',0)
	set(findobj(fighnd,'Tag','ButCreerPlans'),'Enable','on')
	UpdateValeurs
	UpdateRoi
	UpdateColorSpace
case {31,51}
	% rinitialisation ou modif totale
	UpdateValeurs
	UpdateRoi
	UpdateColorSpace	
case {41,61}
	% modif valeurs ou effectif roi
	UpdateValeurs
	UpdateRoi
case 71
	% modif effectif roi
	UpdateRoi
case 81
	% modif ECOL
	UpdateColorSpace
case 111
	% changement de nom cible
	set(findobj(fighnd,'Tag','StxtCibleName'),'String',IsaacImage_get(eventobj,'Name'))
end

% --- Nested fonction ------------------------------------------------------------------------------

function UpdateValeurs

paramr = IsaacImage_get(eventobj,'ParamR');
limits = IsaacImage_get(eventobj,'MinMax');
set(findobj(fighnd,'Tag','StxtDimXVal'),'String',num2str(paramr.dimx))
set(findobj(fighnd,'Tag','StxtDimYVal'),'String',num2str(paramr.dimy))
set(findobj(fighnd,'Tag','StxtDimZVal'),'String',num2str(paramr.dimz))
set(findobj(fighnd,'Tag','StxtEffImageVal'),'String',num2str(paramr.dimx * paramr.dimy))
s = [num2str(paramr.nbbits),' / ',num2str(paramr.bitclass)];
set(findobj(fighnd,'Tag','StxtNbBitsVal'),'String',s)
s= cell(paramr.dimz,1);
ud = get(fighnd,'UserData');
if paramr.nbbits > 16
	formatstr = ['%',num2str(ud.PNBDigits),'i   %1.4f   %1.4f'];
else
	formatstr = ['%',num2str(ud.PNBDigits),'i   %6i   %6i'];
end
for i = 1:paramr.dimz
	s{i} = sprintf(formatstr,i,limits.min(i),limits.max(i));
end
set(findobj(fighnd,'Tag','ListPlans'),'Max',paramr.dimz,'String',s,'Value',1)
% Max-Min > 1 autorise la slection multiple

end % fin nested fonction

% --- Nested fonction ------------------------------------------------------------------------------

function UpdateColorSpace

if IsaacImage_get(eventobj,'IsColorSpace')
	s = IsaacImage_get(eventobj,'ColorSpaceName');
else
	s = 'non dfini';
end	
set(findobj(fighnd,'Tag','StxtECOLVal'),'String',s)

end % fin nested fonction

% --- Nested fonction ------------------------------------------------------------------------------

function UpdateRoi

if ~IsaacImage_get(eventobj,'IsRoi')
	set(findobj(fighnd,'Tag','StxtEffRoiVal'),'String','aucune')
else
	set(findobj(fighnd,'Tag','StxtEffRoiVal'),'String',num2str(IsaacImage_get(eventobj,'RSVEff')))
end	

end % fin nested fonction

%---------------------------------------------------------------------------------------------------

end % fin ImageVal_upd en raison des nested fonctions
