function ImageVue()
% Editeur @IsaacImage de l'aspect visuel de l'image cible
%
% Tool for OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% structure ud : champ UserData
%	ToolDir : rpertoire de l'outil

%---------------------------------------------------------------------------------------------------

global ISAACINFO

% si ImageVue est dj lanc, l'ammener au premier plan.
h = findobj(allchild(0),'flat','Tag','ImageVue');
if ~isempty(h)
	figure(h(1)) % mise au 1er plan
   return
end

hauteurfig = 455;
% figure(position selon ISAACINFO.DefPos)
h0 = figure( ...
	'CloseRequestFcn','ImageVue_cb CloseBox', ...
	'Name','ImageVue', ...
	'Position',IsaacFenPos(ISAACINFO.DefPos(1),ISAACINFO.DefPos(2),205,hauteurfig,0), ...
	'Tag','ImageVue');

IsaacDefaultProperties(h0)

% text CibleName	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Enable','inactive', ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[0 hauteurfig - 15 205 15], ...
	'Style','text', ...
	'Tag','StxtCibleName');
% Texte Plans	
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'Position',[0 hauteurfig - 35 205 15], ...
	'String','Plans ', ...
	'Style','text');
% Popup des plans
uicontrol('Parent',h0, ...
	'Callback','ImageVue_cb PopupPlan1', ...
	'Position',[5 hauteurfig - 55 65 16], ...
	'Style','popupmenu', ...
	'Tag','PopupPlan1');
uicontrol('Parent',h0, ...
	'Callback','ImageVue_cb PopupPlan2', ...
	'Position',[70 hauteurfig - 55 65 16], ...
	'Style','popupmenu', ...
	'Tag','PopupPlan2');
uicontrol('Parent',h0, ...
	'Callback','ImageVue_cb PopupPlan3', ...
	'Position',[135 hauteurfig - 55 65 16], ...
	'Style','popupmenu', ...
	'Tag','PopupPlan3');
% Radioboutons Affichage
uicontrol('Parent',h0, ...
	'Callback','ImageVue_cb RadMarginal', ...
	'String','Marginal', ...
	'Style','radiobutton', ...
	'Position',[20 hauteurfig - 85 70 15], ...
	'Tag','RadMarginal');
uicontrol('Parent',h0, ...
	'Callback','ImageVue_cb RadCouleur', ...
	'String','Couleur', ...
	'Style','radiobutton', ...
	'Position',[115 hauteurfig - 85 65 15], ...
	'Tag','RadCouleur');
% Sparateur
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.TextColor1, ...
	'Enable','inactive', ...
	'Position',[0 hauteurfig - 95 205 1], ...
	'Style','frame');
% Texte Echelle	
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'Position',[0 hauteurfig - 115 205 15], ...
	'String','Echelle', ...
	'Style','text');
% Bouton Echelle-	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor3, ...
	'Callback','ImageVue_cb ButEch-', ...
	'Position',[25 hauteurfig - 135 16 16], ...
	'String','-', ...
	'Tag','ButEch-');
% Bouton EchelleR	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor3, ...
	'Callback','ImageVue_cb ButEchR', ...
	'Position',[43 hauteurfig - 135 16 16], ...
	'String','R', ...
	'Tag','ButEchR');
% Bouton Echelle+	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor3, ...
	'Callback','ImageVue_cb ButEch+', ...
	'Position',[61 hauteurfig - 135 16 16], ...
	'String','+', ...
	'Tag','ButEch+');
% Texte EchelleVal	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Enable','inactive', ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[120 hauteurfig - 135 65 15], ...
	'Style','text', ...
	'Tag','StxtEchVal');
% checkbox Zoom	
uicontrol('Parent',h0, ...
	'Callback','ImageVue_cb ChkZoom', ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'String','Zoom', ...
	'Style','checkbox', ...
	'Position',[60 hauteurfig - 160 55 18], ...
	'Tag','ChkZoom');
% Bouton ZoomReset	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor3, ...
	'Callback','ImageVue_cb ButZoomReset', ...
	'String','R', ...
	'Position',[120 hauteurfig - 159 16 16], ...
	'Tag','ButZoomReset');
% Sparateur
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.TextColor1, ...
	'Enable','inactive', ...
	'Position',[0 hauteurfig - 170 205 1], ...
	'Style','frame');
% Texte Gamma	
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'Position',[0 hauteurfig - 190 205 15], ...
	'String','Gamma', ...
	'Style','text');
% Bouton Gamma-	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor3, ...
	'Callback','ImageVue_cb ButGamma-', ...
	'Position',[25 hauteurfig - 210 16 16], ...
	'String','-', ...
	'Tag','ButGamma-');
% Bouton GammaR
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor3, ...
	'Callback','ImageVue_cb ButGammaR', ...
	'Position',[43 hauteurfig - 210 16 16], ...
	'String','R', ...
	'Tag','ButGammaR');
% Bouton Gamma+	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor3, ...
	'Callback','ImageVue_cb ButGamma+', ...
	'Position',[61 hauteurfig - 210 16 16], ...
	'String','+', ...
	'Tag','ButGamma+');
% Texte GammaVal	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Enable','inactive', ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[120 hauteurfig - 210 65 15], ...
	'Style','text', ...
	'Tag','StxtGammaVal');
% checkbox ExpansionDynamique	
uicontrol('Parent',h0, ...
	'Callback','ImageVue_cb ChkED', ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'String','Expansion dynamique', ...
	'Style','checkbox', ...
	'Position',[35 hauteurfig - 235 150 18], ...
	'Tag','ChkED');
% Sparateur
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.TextColor1, ...
	'Enable','inactive', ...
	'Position',[0 hauteurfig - 245 205 1], ...
	'Style','frame');
% Texte Palette	
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'Position',[0 hauteurfig - 265 205 15], ...
	'String','Palette', ...
	'Style','text');
% popup Palettes
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor1, ...
	'Callback','ImageVue_cb PopupPal', ...
	'Style','popupmenu', ...
	'Position',[15 hauteurfig - 285 175 16], ...
	'Tag','PopupPal');
% Sparateur
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.TextColor1, ...
	'Enable','inactive', ...
	'Position',[0 hauteurfig - 295 205 1], ...
	'Style','frame');
% Texte ROI	
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'Position',[0 hauteurfig - 315 205 15], ...
	'String','ROI', ...
	'Style','text');
% Texte ROIS	
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'FontSize',ISAACINFO.FontSize - 1, ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'Position',[0 hauteurfig - 330 100 15], ...
	'String','Spatiale', ...
	'Style','text');
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'FontSize',ISAACINFO.FontSize - 1, ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'Position',[105 hauteurfig - 330 100 15], ...
	'String','Valeurs', ...
	'Style','text');
% Boutons radio des ROI
uicontrol('Parent',h0, ...
	'Callback','ImageVue_cb ROIS0', ...
	'String','0', ...
	'Style','radiobutton', ...
	'Position',[45 hauteurfig - 350 40 15], ...
	'Tag','ROIS0');
uicontrol('Parent',h0, ...
	'Callback','ImageVue_cb ROISR', ...
	'String','R', ...
	'Style','radiobutton', ...
	'Position',[45 hauteurfig - 370 40 15], ...
	'Tag','ROISR');
uicontrol('Parent',h0, ...
	'Callback','ImageVue_cb ROISC', ...
	'String','C', ...
	'Style','radiobutton', ...
	'Position',[45 hauteurfig - 390 40 15], ...
	'Tag','ROISC');
uicontrol('Parent',h0, ...
	'Callback','ImageVue_cb ROIV0', ...
	'String','0', ...
	'Style','radiobutton', ...
	'Position',[132 hauteurfig - 350 40 15], ...
	'Tag','ROIV0');
uicontrol('Parent',h0, ...
	'Callback','ImageVue_cb ROIVR', ...
	'String','R', ...
	'Style','radiobutton', ...
	'Position',[132 hauteurfig - 370 40 15], ...
	'Tag','ROIVR');
uicontrol('Parent',h0, ...
	'Callback','ImageVue_cb ROIVC', ...
	'String','C', ...
	'Style','radiobutton', ...
	'Position',[132 hauteurfig - 390 40 15], ...
	'Tag','ROIVC');
% checkbox ROIcomp	
uicontrol('Parent',h0, ...
	'Callback','ImageVue_cb ROIcomp', ...
	'String','', ...
	'Style','checkbox', ...
	'Position',[95 hauteurfig - 400 18 18], ...
	'Tag','ROIcomp');
% Texte Complment	
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'FontSize',ISAACINFO.FontSize - 1, ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'Position',[0 hauteurfig - 420 205 15], ...
	'String','Complmentaire', ...
	'Style','text');
% Sparateur
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.TextColor1, ...
	'Enable','inactive', ...
	'Position',[0 hauteurfig - 425 205 1], ...
	'Style','frame');
% Bouton CreerVisuel	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor3, ...
	'Callback','ImageVue_cb ButCreerVisuel', ...
	'Position',[5 hauteurfig - 450 195 20], ...
	'String','Image d''apparence', ...
	'Tag','ButCreerVisuel');

%---------------------------------------------------------------------------------------------------

% Initialisation

ud.ToolDir = fileparts(mfilename('fullpath'));
set(h0,'UserData',ud);
addpath(ud.ToolDir)
IsaacEventUpdListe(h0,ud.ToolDir,'ImageVue_upd') % abonnement aux vnements
cible = IsaacImageCible;
if isempty(cible)
	ImageVue_upd(h0,1,cible,h0)
else
	ImageVue_upd(h0,2,cible,h0)
end
% auteur = ho car accepte les vnements causs par soi-mme pour mise  jour graphique