function ImgEdit()
% Editeur de @IsaacIMG
%
% Tool for OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% structure ud : champ UserData
%	ToolDir		: rpertoire de l'outil
%	PTarget		: 1 = image cible, 2 = mmoire, 3 = fichier, 4  = MATLAB base workspace
%	PVarName    : nom de la variable associe au paramtre dit
%	Param       : objet @IsaacIMG

%---------------------------------------------------------------------------------------------------

global ISAACINFO

% si ImgEdit est dj lanc, l'ammener au premier plan.
h = findobj(allchild(0),'flat','Tag','ImgEdit');
if ~isempty(h)
	figure(h(1)) % mise au 1er plan
   return
end

hauteurfig = 260;
% figure(position selon ISAACINFO.DefPos)
h0 = figure( ...
	'CloseRequestFcn','ImgEdit_cb CloseBox', ...
	'Name','ImgEdit', ...
	'Position',IsaacFenPos(ISAACINFO.DefPos(1),ISAACINFO.DefPos(2),285,hauteurfig,0), ...
	'Tag','ImgEdit');

IsaacDefaultProperties(h0)

% text ParamName	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Enable','inactive', ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[0 hauteurfig - 15 285 15], ...
	'Style','text', ...
	'Tag','StxtParamName');
% text Dimensions
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[0 hauteurfig - 35 285 15], ...
	'String','    Dim X         Dim Y       Dim Z       Nb bits        Effectif', ...
	'Style','text');
% text DimX val
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[5 hauteurfig - 52 47 15], ...
	'Style','text', ...
	'Tag','StxtDimXVal');
% text DimY val
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[57 hauteurfig - 52 47 15], ...
	'Style','text', ...
	'Tag','StxtDimYVal');
% text DimZ val
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[110 hauteurfig - 52 47 15], ...
	'Style','text', ...
	'Tag','StxtDimZVal');
% text NbBits val	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Enable','inactive', ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[162 hauteurfig - 52 47 15], ...
	'Style','text', ...
	'Tag','StxtNbBitsVal');
% text EffImage val	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Enable','inactive', ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[214 hauteurfig - 52 66 15], ...
	'Style','text', ...
	'Tag','StxtEffImg');
% Sparateur ---------------------------------------------------------------------------------------
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.TextColor1, ...
	'Enable','inactive', ...
	'Position',[0 hauteurfig - 60 285 1], ...
	'Style','frame');
% text ROI
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'Position',[0 hauteurfig - 80 285 15], ...
	'String','ROI', ...
	'Style','text');
% text EffRoiS
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[5 hauteurfig - 100 45 15], ...
	'String','Spatiale :', ...
	'Style','text');
% text EffRoiS val	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Enable','inactive', ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[55 hauteurfig - 100 80 15], ...
	'Style','text', ...
	'Tag','StxtEffRoiSval');
% text EffRoiV
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'Position',[150 hauteurfig - 100 45 15], ...
	'String','Valeurs :', ...
	'Style','text');
% text EffRoiV val	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Enable','inactive', ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[200 hauteurfig - 100 80 15], ...
	'Style','text', ...
	'Tag','StxtEffRoiVval');
% Sparateur ---------------------------------------------------------------------------------------
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.TextColor1, ...
	'Enable','inactive', ...
	'Position',[0 hauteurfig - 110 285 1], ...
	'Style','frame');
% text ECOL
uicontrol('Parent',h0, ...
	'ForegroundColor',ISAACINFO.TextColor2, ...
	'HorizontalAlignment','left', ...
	'Position',[5 hauteurfig - 135 40 15], ...
	'String','ECOL :', ...
	'Style','text');
% text ECOL val	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Enable','inactive', ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[50 hauteurfig - 135 230 15], ...
	'Style','text', ...
	'Tag','StxtECOLVal');
% Sparateur ---------------------------------------------------------------------------------------
uicontrol('Parent',h0, ...
	'Enable','inactive', ...
	'Position',[0 hauteurfig - 145 285 1], ...
	'Style','frame');
% text TargetInfo  	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Enable','inactive', ...
	'FontSize',ISAACINFO.FontSize + 1, ...
	'Position',[5 hauteurfig - 165 275 15], ...
	'Style','text', ...
	'Tag','StxtTargetInfo');
% Bouton radio Param image cible
uicontrol('Parent',h0, ...
	'Callback','ImgEdit_cb RadButParamCible', ...
	'String','Image cible', ...
	'Style','radiobutton', ...
	'Position',[5 hauteurfig - 190 190 15], ...
	'Tag','RadButParamCible');
% Bouton radio Param mmoire
uicontrol('Parent',h0, ...
	'Callback','ImgEdit_cb RadButParamMem', ...
	'String','Mmoire', ...
	'Style','radiobutton', ...
	'Position',[5 hauteurfig - 210 100 15], ...
	'Tag','RadButParamMem');
% Bouton radio Param fichier
uicontrol('Parent',h0, ...
	'Callback','ImgEdit_cb RadButParamFich', ...
	'String','Fichier', ...
	'Style','radiobutton', ...
	'Position',[5 hauteurfig - 230 100 15], ...
	'Tag','RadButParamFich');
% Bouton radio Param MATLAB
uicontrol('Parent',h0, ...
	'Callback','ImgEdit_cb RadButParamMATLAB', ...
	'String','MATLAB', ...
	'Style','radiobutton', ...
	'Position',[5 hauteurfig - 250 100 15], ...
	'Tag','RadButParamMATLAB');
% edit Varname	
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor2, ...
	'Callback','ImgEdit_cb EtxtVarname', ...
	'FontSize',ISAACINFO.FontSize, ...
	'Position',[90 hauteurfig - 253 80 22], ...
	'Style','edit', ...
	'Tag','EtxtVarname');
% bouton ParamPull
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor3, ...
	'Callback','ImgEdit_cb ButParamPull', ...
	'Position',[190 hauteurfig - 230 90 20], ...
	'String','Editer', ...
	'Tag','ButParamPull');
% bouton ParamPush
uicontrol('Parent',h0, ...
	'BackgroundColor',ISAACINFO.IsaacColor3, ...
	'Callback','ImgEdit_cb ButParamPush', ...
	'Position',[190 hauteurfig - 255 90 20], ...
	'String','Modifier', ...
	'Tag','ButParamPush');

%---------------------------------------------------------------------------------------------------

% Initialisation

ud.ToolDir = fileparts(mfilename('fullpath'));
ud.PTarget = 1; % image cible
ud.Param = [];
ud.PVarName = 'x';
set(findobj(h0,'Tag','EtxtVarname'),'String',ud.PVarName,'Visible','off')
set(findobj(h0,'Tag','RadButParamCible'),'Value',1)
set(h0,'UserData',ud);
addpath(ud.ToolDir)
IsaacEventUpdListe(h0,ud.ToolDir,'ImgEdit_upd') % abonnement aux vnements
cible = IsaacImageCible;
if isempty(cible)
	ImgEdit_upd(h0,1,cible,NaN)
else
	ImgEdit_upd(h0,2,cible,NaN)
end
% auteur = NaN car n'accepte pas les vnements causs par soi-mme pour mise  jour graphique