function ImgEdit_cb(choix)
% Callback ImgEdit
%
% Tool for OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% N'utilise pas la rception d'vnements causs par (auteur = soi-mme) pour mise  jour graphique

%---------------------------------------------------------------------------------------------------

global ISAACINFO

switch(choix)
case 'CloseBox'
	ud = get(gcbf,'UserData');
	if ~ISAACINFO.IsEnd
		IsaacEventUpdListe(gcbf,[])
	end
	rmpath(ud.ToolDir)
	closereq
case 'RadButParamCible'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.PTarget = 1;
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		set(findobj(gcbf,'Tag','ButParamPull'),'String','Editer')
		set(findobj(gcbf,'Tag','ButParamPush'),'String','Modifier')
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','off')
		cible = IsaacImageCible;
		if isempty(cible)
			ImgEdit_upd(gcbf,1,cible,NaN)
		else
			ImgEdit_upd(gcbf,2,cible,NaN)
		end
		% auteur = NaN car ImgEdit_upd n'accepte pas les vnements causs par soi-mme
	else % tait 1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButParamMem'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.PTarget = 2;
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','RadButParamCible'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		set(findobj(gcbf,'Tag','ButParamPull'),'Enable','on','String','Lire')
		if isempty(ud.Param)
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','off','String','Ecrire')
		else
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','on','String','Ecrire')
		end
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','off')
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
	else % tait 1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButParamFich'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.PTarget = 3;
		set(gcbf,'UserData',ud);
		set(findobj(gcbf,'Tag','RadButParamCible'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMATLAB'),'Value',0)
		set(findobj(gcbf,'Tag','ButParamPull'),'Enable','on','String','Ouvrir...')
		if isempty(ud.Param)
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','off','String','Sauver sous...')
		else
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','on','String','Sauver sous...')
		end
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','off')
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
	else % tait 1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadButParamMATLAB'
	v = get(gcbo,'Value');
	if v == 1 % tait 0 vient d'tre mis  1
		ud = get(gcbf,'UserData');
		ud.PTarget = 4;
		set(gcbf,'UserData',ud)
		set(findobj(gcbf,'Tag','RadButParamCible'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamMem'),'Value',0)
		set(findobj(gcbf,'Tag','RadButParamFich'),'Value',0)
		set(findobj(gcbf,'Tag','ButParamPull'),'Enable','on','String','Importer')
		if isempty(ud.Param)
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','off','String','Exporter')
		else
			set(findobj(gcbf,'Tag','ButParamPush'),'Enable','on','String','Exporter')
		end
		set(findobj(gcbf,'Tag','EtxtVarname'),'Visible','on')
		set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
	else % tait  1 vient d'tre mis  0
		set(gcbo,'Value',1)	
	end
case 'EtxtVarname'
	ud = get(gcbf,'UserData');
	ud.PVarName = get(gcbo,'String');
	set(gcbf,'UserData',ud);
	set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
case 'ButParamPull'
	ud = get(gcbf,'UserData');
	switch ud.PTarget
		case 1 % Image Cible
			cible = IsaacImageCible;
			ud.Param = IsaacImage_get(cible,'IMG');
			set(gcbf,'UserData',ud);
			MajWhenPull
		case 2 % Mmoire
			P = IsaacParamPull('IMG');
			if isempty(P)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','mmoire vide')
			else
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String','mmoire lue')
				ud.Param = P;
				set(gcbf,'UserData',ud);
				MajWhenPull
			end	
		case 3 % Fichier
			[filename,dirname] = IsaacUIgetfile('Ouvrir une image :');
			if filename == 0
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
				return
			end
			try
				ud.Param = IsaacIMG(fullfile(dirname,filename));
				IsaacCD(dirname)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['fichier ',filename,' lu'])
				set(gcbf,'UserData',ud);
				MajWhenPull
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec lecture fichier')
				return
			end
		case 4 % MATLAB base workspace
			try
				ud.Param = IsaacParamImport('IMG',ud.PVarName);
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['variable ',ud.PVarName,' importe'])
				set(gcbf,'UserData',ud);
				MajWhenPull
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec import MATLAB')
				return
			end	
	end
case 'ButParamPush'
	ud = get(gcbf,'UserData');
	switch ud.PTarget
		case 1 % Image Cible
			cible = IsaacImageCible;
			try
 				IsaacImage_set(cible,gcbf,'IMG',ud.Param);
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				return
			end
		case 2 % Mmoire
			IsaacParamPush(ud.Param)
			set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
				'String','IMG mmorise')
		case 3 % Fichier
			[filename,dirname] = IsaacUIputfile('Sauver sous :', ...
				IsaacImgFileName(IsaacIMG_get(ud.Param,'ImgName')));
			if filename == 0
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'String','')
				return
			end
			try
				IsaacIMG_saveas(ud.Param,fullfile(dirname,filename));
				IsaacCD(dirname)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
				'String',['fichier ',filename,' sauv'])
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec criture fichier')
				return
			end
		case 4 % MATLAB base workspace
			try
				IsaacParamExport(ud.Param,ud.PVarName)
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor1, ...
					'String',['variable ',ud.PVarName,' exporte'])
			catch exception
				IsaacMessageErreur(IsaacError(exception))
				set(findobj(gcbf,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACINFO.TextColor3, ...
					'String','chec export MATLAB')
				return
			end	
	end
end

% --- Nested fonction ------------------------------------------------------------------------------

function MajWhenPull

set(findobj(gcbf,'Tag','StxtParamName'),'String',IsaacIMG_get(ud.Param,'ImgName'))
dimx = IsaacIMG_get(ud.Param,'DimX');
dimy = IsaacIMG_get(ud.Param,'DimY');
set(findobj(gcbf,'Tag','StxtDimXVal'),'String',num2str(dimx))
set(findobj(gcbf,'Tag','StxtDimYVal'),'String',num2str(dimy))
set(findobj(gcbf,'Tag','StxtDimZVal'),'String',num2str(IsaacIMG_get(ud.Param,'DimZ')))
s = [num2str(IsaacIMG_get(ud.Param,'NbBits')),' / ',num2str(IsaacIMG_get(ud.Param,'BitClass'))];
set(findobj(gcbf,'Tag','StxtNbBitsVal'),'String',s)
set(findobj(gcbf,'Tag','StxtEffImg'),'String',num2str(dimx * dimy))
set(findobj(gcbf,'Tag','ButParamPush'),'Enable','on')
if IsaacIMG_get(ud.Param,'IsRoiSpa')
	s = num2str(IsaacIMG_get(ud.Param,'RoiSpaEff'));
else
	s = 'aucune';
end
set(findobj(gcbf,'Tag','StxtEffRoiSval'),'String',s)
if IsaacIMG_get(ud.Param,'IsRoiVal')
	s = num2str(IsaacIMG_get(ud.Param,'RoiValEff'));
else
	s = 'aucune';
end
set(findobj(gcbf,'Tag','StxtEffRoiVval'),'String',s)
if IsaacIMG_get(ud.Param,'IsColorSpace')
	s = IsaacIMG_get(ud.Param,'ColorSpaceName');
else
	s = 'non dfini';
end
set(findobj(gcbf,'Tag','StxtECOLVal'),'String',s)

end % fin nested fonction

%---------------------------------------------------------------------------------------------------

end % fin ImgEdit_cb en raison des nested fonctions

