function IsaacModBox_upd(fighnd,event,eventobj,auteur)
% Raction IsaacModBox aux vnements recus
%
% @<- EVENEMENTS 2/11/12/111/112
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

% N'accepte pas les vnements causs par (auteur = soi-mme) pour mise  jour graphique

%---------------------------------------------------------------------------------------------------

if auteur == fighnd 
 	return
end	

global ISAACPREF

switch event	
case 2
	% changement de cible
	ud = get(fighnd,'UserData');
	if (ud.PTarget == 2)
		UpdateTargetInfo(true)
	end	
case 11
	% (avant) fermeture image cible
	ud = get(fighnd,'UserData');
	if (ud.PTarget == 2)
		UpdateTargetInfo(false)
	end	
	ReinitListParam
case 12	
	% (avant) fermeture image non cible
	ud = get(fighnd,'UserData');
	ReinitListParam
case 111	
	% changement de nom image cible
	ud = get(fighnd,'UserData');
	if (ud.PTarget == 2)
		UpdateTargetInfo(true)
	end	
	UpdateListParam
case 112									
	% changement de nom image non cible
	ud = get(fighnd,'UserData');
	UpdateListParam
	end

% --- Nested fonction ------------------------------------------------------------------------------

function UpdateTargetInfo(iscible)
% Mise  jour du champ texte TargetInfo
if iscible
	set(findobj(fighnd,'Tag','ButParamValider'),'Enable','on')
	set(findobj(fighnd,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACPREF.TextColor1, ...
		'String',IsaacImage_get(eventobj,'Name'))
else
	set(findobj(fighnd,'Tag','ButParamValider'),'Enable','off')
	set(findobj(fighnd,'Tag','StxtTargetInfo'),'ForegroundColor',ISAACPREF.TextColor3, ...
		'String','pas d''image cible')
end	

end % fin nested fonction

% --- Nested fonction ------------------------------------------------------------------------------

function ReinitListParam
% Mise  jour des listes de paramtres en cas de fermeture d'une image ouverte slectionne

SList = {'ListParam_E','ListParam_S'};
ischange = [false,false];
for i = 1:2	
	for j = 1:ud.ParamNb(i)
		opval = ud.Param{i}(j).options(ud.Param{i}(j).opidx);
		if (opval == 2)
			% image ouverte
			if ud.Param{i}(j).val == eventobj
				% l'image slectionne va tre ferme
				imgname = ud.Param{i}(j).nom;
				ud.Param{i}(j).ok = false;
				ud.Param{i}(j).nom = ud.ParamInfo{i}{2*j};
				ud.Param{i}(j).val = [];
				ud.Param{i}(j).affi = sprintf('%-10s: %s',ud.Param{i}(j).label,ud.Param{i}(j).nom);
				ischange(i) = true;
			end
		end	
	end
	if ischange(i)
		set(findobj(fighnd,'Tag',SList{i}),'String',{ud.Param{i}.affi})
	end	
end
if any(ischange)
	% un seul message pour ventuellement plusieurs paramtres ferms (mme image eventobj)
	IsaacMessageWarning(['image ',imgname,' ferme'])
	set(findobj(fighnd,'Tag','ButDo'),'Enable','off')
	set(fighnd,'UserData',ud)
end	

end % fin nested fonction

% --- Nested fonction ------------------------------------------------------------------------------

function UpdateListParam
% Mise  jour des listes de paramtres en cas de changement de nom d'une image ouverte slectionne

SList = {'ListParam_E','ListParam_S'};
ischange = [false,false];
for i = 1:2
	for j = 1:ud.ParamNb(i)
		opval = ud.Param{i}(j).options(ud.Param{i}(j).opidx);
		if (opval == 2)
			% image ouverte
			if ud.Param{i}(j).val == eventobj
				% l'image slectionne a chang de nom
				newname = IsaacImage_get(eventobj,'Name');
				oldname = ud.Param{i}(j).nom;
				if ~strcmp(newname,oldname)
					% l'image a pu changer de nom pour un nom identique
					ud.Param{i}(j).nom = newname;
					ud.Param{i}(j).affi = sprintf('%-5s : %s : %s',ud.Param{i}(j).label,'I', ...
						ud.Param{i}(j).nom);
					ischange(i) = true;
				end	
			end	
		end
	end
	if ischange(i)
		set(findobj(fighnd,'Tag',SList{i}),'String',{ud.Param{i}.affi})
	end	
end		
if any(ischange)
	% un seul message pour ventuellement plusieurs paramtres renomms (mme image eventobj)
	IsaacMessageWarning(['image ',oldname,' renomme ',newname])
	set(fighnd,'UserData',ud)
end

end % fin nested fonction

%---------------------------------------------------------------------------------------------------

end % fin IsaacModBox_upd en raison des nested fonctions
