function IsaacPrefs_cb(choix)
% Callback IsaacPrefs
%
% OpenIsaac
%  2018 Alain Clment - Universit d'Angers

%---------------------------------------------------------------------------------------------------

% Copyright 2007 - 2018 Universit d'Angers - Author: Alain Clment
%
% This program is free software; you can redistribute it and/or modify it under the terms of the GNU
% General Public License as published by the Free Software Foundation; either version 3 of the
% License, or any later version. This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
% PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received
% a copy of the GNU General Public License along with this program; if not, write to the Free
% Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

%---------------------------------------------------------------------------------------------------

global ISAACCONST
global ISAACPREF
global ISAACINFO

switch(choix)
case 'RadUser'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		set(findobj(gcbf,'Tag','RadDevelop'),'Value',0)
		set(findobj(gcbf,'Tag','RadDebug'),'Value',0)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadDevelop'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		set(findobj(gcbf,'Tag','RadUser'),'Value',0)
		set(findobj(gcbf,'Tag','RadDebug'),'Value',0)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end
case 'RadDebug'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		set(findobj(gcbf,'Tag','RadUser'),'Value',0)
		set(findobj(gcbf,'Tag','RadDevelop'),'Value',0)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end
case 'ButDefaultDir'
	dirname = IsaacUIgetdir('Slectionner le dossier :');
	if dirname
		set(gcbo,'ForegroundColor',ISAACPREF.TextColor1,'String',IsaacPathStr(dirname,2))
		ud = get(gcbf,'UserData');
		ud.DefaultDir = dirname;
		set(gcbf,'UserData',ud)
		parentdir = fileparts(dirname);
		IsaacCD(parentdir)
	end	        	
case 'ChkUserToolsDir'
	ud = get(gcbf,'UserData');
	coul = ISAACPREF.TextColor1; % couleur de texte par dfaut
	v = get(gcbo,'Value');
	if v == 0 % tait  1 et vient d'tre mis  0
		s1 = 'off';
		s2 = '';
		ud.UserToolsDir = '';
		set(gcbf,'UserData',ud)
	else % tait  0 et vient d'tre mis  1
		s1 = 'on';
		if isempty(ud.UserToolsDir)
			s2 = 'Cliquer pour choisir un dossier ...';
			coul = ISAACPREF.TextColor3;
		else
			s2 = IsaacPathStr(ud.UserToolsDir,2);
		end    
	end    
	set(findobj(gcbf,'Tag','ButUserToolsDir'),'Enable',s1,'ForegroundColor',coul,'String',s2);
case 'ButUserToolsDir'
	dirname = IsaacUIgetdir('Slectionner le dossier :');
	if dirname
		set(gcbo,'ForegroundColor',ISAACPREF.TextColor1,'String',IsaacPathStr(dirname,2))
		ud = get(gcbf,'UserData');
		ud.UserToolsDir = dirname;
		set(gcbf,'UserData',ud)
		parentdir = fileparts(dirname);
		IsaacCD(parentdir)
	end
case 'ChkUserModsDir'
	ud = get(gcbf,'UserData');
	coul = ISAACPREF.TextColor1; % couleur de texte par dfaut
	v = get(gcbo,'Value');
	if v == 0 % tait  1 et vient d'tre mis  0
		s1 = 'off';
		s2 = '';
		ud.UserModsDir = '';
		set(gcbf,'UserData',ud)
	else % tait  0 et vient d'tre mis  1
		s1 = 'on';
		if isempty(ud.UserModsDir)
			s2 = 'Cliquer pour choisir un dossier ...';
			coul = ISAACPREF.TextColor3;
		else
			s2 = IsaacPathStr(ud.UserModsDir,2);
		end
	end    
	set(findobj(gcbf,'Tag','ButUserModsDir'),'Enable',s1,'ForegroundColor',coul,'String',s2);
case 'ButUserModsDir'
	dirname = IsaacUIgetdir('Slectionner le dossier :');
   if dirname
		set(gcbo,'ForegroundColor',ISAACPREF.TextColor1,'String',IsaacPathStr(dirname,2))
		ud = get(gcbf,'UserData');
		ud.UserModsDir = dirname;
		set(gcbf,'UserData',ud)
		parentdir = fileparts(dirname);
		IsaacCD(parentdir)
   end
case 'RadSerQual'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		set(findobj(gcbf,'Tag','RadSerMem'),'Value',0)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadSerMem'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		set(findobj(gcbf,'Tag','RadSerQual'),'Value',0)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadImgSpeed'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		set(findobj(gcbf,'Tag','RadImgMem'),'Value',0)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadImgMem'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		set(findobj(gcbf,'Tag','RadImgSpeed'),'Value',0)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end  
case 'RadISA'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		set(findobj(gcbf,'Tag','RadTIF'),'Value',0)
		set(findobj(gcbf,'Tag','RadBMP'),'Value',0)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end	
case 'RadTIF'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		set(findobj(gcbf,'Tag','RadISA'),'Value',0)
		set(findobj(gcbf,'Tag','RadBMP'),'Value',0)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end
case 'RadBMP'
	v = get(gcbo,'Value');
	if v == 1 % tait  0 et vient d'tre mis  1
		set(findobj(gcbf,'Tag','RadTIF'),'Value',0)
		set(findobj(gcbf,'Tag','RadISA'),'Value',0)
	else % tait  1 et vient d'tre mis  0
		set(gcbo,'Value',1)	
	end
case 'EtxtMaxPlans'
	ud = get(gcbf,'UserData');
	vstr = get(gcbo,'String');
	v = round(str2double(vstr));
	if (isnan(v) || ~isequal(size(v),[1 1]) || (v < 3) || (v > ISAACCONST.ImMaxZ)) 
		IsaacSound('Buzz')
		set(gcbo,'String',num2str(ud.ImMaxPlans))
	else
		set(gcbo,'String',num2str(v))
		ud.ImMaxPlans = v;
	end
	set(gcbf,'UserData',ud)
case 'ChkSon'
	v = get(gcbo,'Value');
   if v == true % tait false vient d'tre mis  true
		ISAACPREF.Son = true;
		IsaacSound('Info')
		ISAACPREF.Son = false;
   end
case 'ButPolice'
	S = uisetfont(gcbo,'Choisir police et taille :');
	if isstruct(S)
		set(gcbo,'FontName',S.FontName,'FontSize',S.FontSize, ...
			'String',[S.FontName,' ',num2str(S.FontSize)])
	end	
case 'ButIsaacColor1'
	set(gcbo,'BackgroundColor',uisetcolor(ISAACPREF.IsaacColor1,'Choisir la couleur :'))
case 'ButIsaacColor2'
	set(gcbo,'BackgroundColor',uisetcolor(ISAACPREF.IsaacColor2,'Choisir la couleur :'))
case 'ButIsaacColor3'
	set(gcbo,'BackgroundColor',uisetcolor(ISAACPREF.IsaacColor3,'Choisir la couleur :'))
case 'ButTextColor1'
	set(gcbo,'BackgroundColor',uisetcolor(ISAACPREF.TextColor1,'Choisir la couleur :'))
case 'ButTextColor2'
	set(gcbo,'BackgroundColor',uisetcolor(ISAACPREF.TextColor2,'Choisir la couleur :'))
case 'ButTextColor3'
	set(gcbo,'BackgroundColor',uisetcolor(ISAACPREF.TextColor3,'Choisir la couleur :'))
case 'ButCibleColor1'
	set(gcbo,'BackgroundColor',uisetcolor(ISAACPREF.CibleColor1,'Choisir la couleur :'))
case 'ButCibleColor2'
	set(gcbo,'BackgroundColor',uisetcolor(ISAACPREF.CibleColor2,'Choisir la couleur :'))
case 'ButROIColor1'
	set(gcbo,'BackgroundColor',uisetcolor(im2double(ISAACPREF.ROIColor1),'Choisir la couleur :'))
case 'ButROIColor2'
	set(gcbo,'BackgroundColor',uisetcolor(im2double(ISAACPREF.ROIColor2),'Choisir la couleur :'))
case 'ButROIColor3'
	set(gcbo,'BackgroundColor',uisetcolor(im2double(ISAACPREF.ROIColor3),'Choisir la couleur :'))
case 'ButROIColor4'
	set(gcbo,'BackgroundColor',uisetcolor(im2double(ISAACPREF.ROIColor4),'Choisir la couleur :'))
case 'ButReset'
	% Effacement du fichier de prfrences
	try
		oldstate = recycle;
		recycle('off'); % effacement immdiat
      fname = [ISAACCONST.Info.IsaacName,ISAACCONST.Info.IsaacVersion,'Prefs.mat'];
      delete(fullfile(ISAACCONST.PrefDir,fname))
		recycle(oldstate)
	catch exception
		IsaacMessageErreur(IsaacError(exception))
	end
	closereq
	IsaacSound('OpenClose')
	IsaacEngine('-restart')
case 'ButCancel'
	closereq
case 'ButOk'
	ud = get(gcbf,'UserData');
	% Ecriture des prfrences
	v = get(findobj(gcbf,'Tag','RadUser'),'Value');
	if v == 1
		if ISAACPREF.Mode ~= 1
			ud.Restart = true;
		end	
		ISAACPREF.Mode = 1;
	else
		v = get(findobj(gcbf,'Tag','RadDevelop'),'Value');
		if v == 1
			if ISAACPREF.Mode == 1
				ud.Restart = true;
			end	
			ISAACPREF.Mode = 2;
		else
			if ISAACPREF.Mode == 1
				ud.Restart = true;
			end	
			ISAACPREF.Mode = 3;
		end	
	end
	ISAACPREF.DefaultDir = ud.DefaultDir;
   if ~strcmp(ud.UserToolsDir,ISAACPREF.UserToolsDir)
		ud.Restart = true;
		ISAACPREF.UserToolsDir = ud.UserToolsDir;
   end    
   if ~strcmp(ud.UserModsDir,ISAACPREF.UserModsDir)
		ud.Restart = true;
		ISAACPREF.UserModsDir = ud.UserModsDir;
   end
   v = get(findobj(gcbf,'Tag','RadSerMem'),'Value');
	ISAACPREF.OptimiseSerMem = v;
	v = get(findobj(gcbf,'Tag','RadImgMem'),'Value');
	ISAACPREF.OptimiseImgMem = v;
   v = get(findobj(gcbf,'Tag','RadISA'),'Value');
	if v == 1
		ISAACPREF.ImForm = ISAACCONST.ExtImg;
	else
		v = get(findobj(gcbf,'Tag','RadTIF'),'Value');
		if v == 1
			ISAACPREF.ImForm = '.tif';
		else
			ISAACPREF.ImForm = '.bmp';
		end	
	end
	if ISAACPREF.ImMaxPlans ~= ud.ImMaxPlans
		ud.Restart = true;
	end	
	ISAACPREF.ImMaxPlans    = ud.ImMaxPlans;
	ISAACPREF.ImFullName    = get(findobj(gcbf,'Tag','ChkImFullName'),'Value');
   ISAACPREF.ShowImType    = get(findobj(gcbf,'Tag','ChkShowImType'),'Value');
	ISAACPREF.Son           = get(findobj(gcbf,'Tag','ChkSon'),'Value');
	ISAACPREF.CloseMenuEnd  = get(findobj(gcbf,'Tag','ChkSCloseMenuEnd'),'Value'); 
   ISAACPREF.FontName      = get(findobj(gcbf,'Tag','ButPolice'),'FontName');
	ISAACPREF.FontSize      = get(findobj(gcbf,'Tag','ButPolice'),'FontSize');
	ISAACPREF.IsaacColor1	= get(findobj(gcbf,'Tag','ButIsaacColor1'),'BackgroundColor');
	ISAACPREF.IsaacColor2	= get(findobj(gcbf,'Tag','ButIsaacColor2'),'BackgroundColor');
	ISAACPREF.IsaacColor3	= get(findobj(gcbf,'Tag','ButIsaacColor3'),'BackgroundColor');
	ISAACPREF.TextColor1    = get(findobj(gcbf,'Tag','ButTextColor1'),'BackgroundColor');
	ISAACPREF.TextColor2    = get(findobj(gcbf,'Tag','ButTextColor2'),'BackgroundColor');
	ISAACPREF.TextColor3    = get(findobj(gcbf,'Tag','ButTextColor3'),'BackgroundColor');
	ISAACPREF.CibleColor1	= get(findobj(gcbf,'Tag','ButCibleColor1'),'BackgroundColor');
	ISAACPREF.CibleColor2	= get(findobj(gcbf,'Tag','ButCibleColor2'),'BackgroundColor');
	ISAACPREF.ROIColor1		= im2uint8(get(findobj(gcbf,'Tag','ButROIColor1'),'BackgroundColor'));
	ISAACPREF.ROIColor2		= im2uint8(get(findobj(gcbf,'Tag','ButROIColor2'),'BackgroundColor'));
	ISAACPREF.ROIColor3		= im2uint8(get(findobj(gcbf,'Tag','ButROIColor3'),'BackgroundColor'));
	ISAACPREF.ROIColor4		= im2uint8(get(findobj(gcbf,'Tag','ButROIColor4'),'BackgroundColor'));

   fname = [ISAACCONST.Info.IsaacName,ISAACCONST.Info.IsaacVersion,'Prefs.mat'];
	save(fullfile(ISAACCONST.PrefDir,fname),'ISAACPREF')
	
	% Recopie ISAACINFO
	ISAACINFO.FontName		= ISAACPREF.FontName;
	ISAACINFO.FontSize		= ISAACPREF.FontSize;
	ISAACINFO.ImMaxPlans    = ISAACPREF.ImMaxPlans;
	ISAACINFO.IsaacColor1	= ISAACPREF.IsaacColor1;
	ISAACINFO.IsaacColor2	= ISAACPREF.IsaacColor2;
	ISAACINFO.IsaacColor3	= ISAACPREF.IsaacColor3;
	ISAACINFO.ROIColor1		= ISAACPREF.ROIColor1;
	ISAACINFO.ROIColor2		= ISAACPREF.ROIColor2;
	ISAACINFO.ROIColor3		= ISAACPREF.ROIColor3;
	ISAACINFO.ROIColor4		= ISAACPREF.ROIColor4;
	ISAACINFO.TextColor1    = ISAACPREF.TextColor1;
	ISAACINFO.TextColor2    = ISAACPREF.TextColor2;
	ISAACINFO.TextColor3    = ISAACPREF.TextColor3;

	closereq
	if ud.Restart
		IsaacSound('OpenClose')
		IsaacEngine('-restart')
	end	
end		
